var init = function () {
    var editor_htmlCode;
    var editor_jsCode;

    var init_editor = function () {
        var code = window.name;

        var htmlCode = utils.getHtmlCode(code);
        var jsCode = utils.getJsCode(code);

        if (!editor_htmlCode) {
            editor_htmlCode = CodeMirror.fromTextArea(document.getElementById('textarea_htmlCode'), {
                lineNumbers: true,
                theme: 'abcdef',
                lineWrapping: true,
                mode: 'htmlembedded'
            });
        }
        editor_htmlCode.setValue(htmlCode);

        if (!editor_jsCode) {
            editor_jsCode = CodeMirror.fromTextArea(document.getElementById('textarea_jsCode'), {
                lineNumbers: true,
                theme: 'abcdef',
                lineWrapping: true,
                mode: 'javascript'
            });
        }
        editor_jsCode.setValue(jsCode);
    };

    var init_eventBind = function () {
        $('.btn-run').click(function () {
            var getHtmlCode = function () {
                var str = editor_htmlCode.getValue();
                str = '<html><body>' + str + '</body></html>';
                return str;
            };
            var getJsCode = function () {
                var str = editor_jsCode.getValue();
                str = '<script>' + str + '</script>';
                return str;
            };

            var htmlCode = getHtmlCode();
            var jsCode = getJsCode();
            var code = htmlCode + jsCode;

            var iframePreview = document.getElementById('iframe-preview');
            iframePreview.contentWindow.name = code;
            iframePreview.src = 'run-code.html';

            iFrameResize({log: false});
        });

        $('.btn-reset').click(function () {
            var iframePreview = document.getElementById('iframe-preview');
            iframePreview.contentWindow.name = '';
            iframePreview.src = '';
            iFrameResize({log: false});

            init_editor();
        });
    };

    init_editor();
    init_eventBind();
};

init();