//<editor-fold desc="dataBase.classEntityList">
(function () {
    dataBase.classEntityList = _.map(dataBase.classes, function (m) {
        return m;
    });

    _.each(dataBase.classEntityList, function (classEntity) {
        classEntity.classId = classEntity.name.replace(/\//gi, '_');

        _.each(classEntity.demoEntityList, function (demoEntity) {
            demoEntity.anchor = {};
            demoEntity.anchor.data = {};
            demoEntity.anchor.data.name = demoEntity.title;
            demoEntity.anchor.data.anchor = `${classEntity.name}-Constructor-demo-${demoEntity.title}`;
            demoEntity.anchor.data.level = 3;
        });

        classEntity.methodEntityList = _.filter(dataBase.classitems, function (m) {
            return m.class === classEntity.name && m.itemtype === 'method';
        });
        classEntity.methodEntityList = _.sortBy(classEntity.methodEntityList, function (m) {
            return m.name;
        });
        _.each(classEntity.methodEntityList, function (methodEntity) {
            methodEntity.anchor = {};
            methodEntity.anchor.data = {};
            methodEntity.anchor.data.name = methodEntity.name;
            methodEntity.anchor.data.anchor = `${classEntity.name}-method-${methodEntity.name}`;
            methodEntity.anchor.data.level = 2;

            _.each(methodEntity.demoEntityList, function (demoEntity) {
                demoEntity.anchor = {};
                demoEntity.anchor.data = {};
                demoEntity.anchor.data.name = demoEntity.title;
                demoEntity.anchor.data.anchor = `${classEntity.name}-method-${methodEntity.name}-demo-${demoEntity.title}`;
                demoEntity.anchor.data.level = 3;
            });
        });

        classEntity.propertyEntityList = _.filter(dataBase.classitems, function (m) {
            return m.class === classEntity.name && m.itemtype === 'property';
        });
        classEntity.propertyEntityList = _.sortBy(classEntity.propertyEntityList, function (m) {
            return m.name;
        });
        _.each(classEntity.propertyEntityList, function (propertyEntity) {
            propertyEntity.anchor = {};
            propertyEntity.anchor.data = {};
            propertyEntity.anchor.data.name = propertyEntity.name;
            propertyEntity.anchor.data.anchor = `${classEntity.name}-property-${propertyEntity.name}`;
            propertyEntity.anchor.data.level = 2;

            _.each(propertyEntity.demoEntityList, function (demoEntity) {
                demoEntity.anchor = {};
                demoEntity.anchor.data = {};
                demoEntity.anchor.data.name = demoEntity.title;
                demoEntity.anchor.data.anchor = `${classEntity.name}-property-${propertyEntity.name}-demo-${demoEntity.title}`;
                demoEntity.anchor.data.level = 3;
            });
        });

        //classEntity.allDemoEntityList处理
        classEntity.allDemoEntityList = [];
        if (classEntity.demoEntityList) {
            classEntity.allDemoEntityList = classEntity.allDemoEntityList.concat(classEntity.demoEntityList);
        }
        _.each(classEntity.methodEntityList, function (m) {
            if (!m.demoEntityList) {
                return;
            }
            classEntity.allDemoEntityList = classEntity.allDemoEntityList.concat(m.demoEntityList);
        });
        _.each(classEntity.propertyEntityList, function (m) {
            if (!m.demoEntityList) {
                return;
            }
            classEntity.allDemoEntityList = classEntity.allDemoEntityList.concat(m.demoEntityList);
        });

        //classEntity.allMochaEntityList处理
        classEntity.allMochaEntityList = [];
        if (classEntity.mochaEntityList) {
            classEntity.allMochaEntityList = classEntity.allMochaEntityList.concat(classEntity.mochaEntityList);
        }
        _.each(classEntity.methodEntityList, function (m) {
            if (!m.mochaEntityList) {
                return;
            }
            classEntity.allMochaEntityList = classEntity.allMochaEntityList.concat(m.mochaEntityList);
        });
        _.each(classEntity.propertyEntityList, function (m) {
            if (!m.mochaEntityList) {
                return;
            }
            classEntity.allMochaEntityList = classEntity.allMochaEntityList.concat(m.mochaEntityList);
        });

        //classEntity.runMochaEntityList处理
        classEntity.runMochaEntityList = [];
        (function () {
            var query1 = _(classEntity.allDemoEntityList)
                .filter(function (m) {
                    return m.option.buildType === '100';
                })
                .map(function (m) {
                    return {
                        path: m.path_file_mocha_js
                    };
                })
            ;
            classEntity.runMochaEntityList = classEntity.runMochaEntityList.concat(query1);

            var query2 = _(classEntity.allMochaEntityList)
                .map(function (m) {
                    return {
                        path: m.path
                    };
                })
            ;
            classEntity.runMochaEntityList = classEntity.runMochaEntityList.concat(query2);
        })();

        //锚点处理：classEntity.anchor.data
        classEntity.anchor = {};
        classEntity.anchor.data = {};
        classEntity.anchor.data.Name = `anchor-${classEntity.name}-Name`;
        classEntity.anchor.data.Constructor = `anchor-${classEntity.name}-Constructor`;
        classEntity.anchor.data.Method = `anchor-${classEntity.name}-Method`;
        classEntity.anchor.data.Property = `anchor-${classEntity.name}-Property`;

        //锚点处理：classEntity.anchor.list
        classEntity.anchor.list = [];

        //<editor-fold desc="Name">
        classEntity.anchor.list.push({
            name: 'Name',
            anchor: classEntity.anchor.data.Name,
            level: 1
        });
        //</editor-fold>

        //<editor-fold desc="Constructor">
        classEntity.anchor.list.push({
            name: 'Constructor',
            anchor: classEntity.anchor.data.Constructor,
            level: 1
        });
        _.each(classEntity.demoEntityList, function (demoEntity) {
            classEntity.anchor.list.push(demoEntity.anchor.data);
        });
        //</editor-fold>

        //<editor-fold desc="Method">
        classEntity.anchor.list.push({
            name: 'Method',
            anchor: classEntity.anchor.data.Method,
            level: 1
        });
        _.each(classEntity.methodEntityList, function (methodEntity) {
            var entity = methodEntity.anchor.data;
            classEntity.anchor.list.push(entity);

            _.each(methodEntity.demoEntityList, function (demoEntity) {
                var entity = demoEntity.anchor.data;
                classEntity.anchor.list.push(entity);
            });
        });
        //</editor-fold>

        //<editor-fold desc="Property">
        classEntity.anchor.list.push({
            name: 'Property',
            anchor: classEntity.anchor.data.Property,
            level: 1
        });
        _.each(classEntity.propertyEntityList, function (propertyEntity) {
            var entity = propertyEntity.anchor.data;
            classEntity.anchor.list.push(entity);

            _.each(propertyEntity.demoEntityList, function (demoEntity) {
                var entity = demoEntity.anchor.data;
                classEntity.anchor.list.push(entity);
            });
        });
        //</editor-fold>

    });
})();
//</editor-fold>

//<editor-fold desc="dataBase.allMochaEntityList">
(function () {
    var allMochaEntityList = [];
    _.each(dataBase.classEntityList, function (classEntity) {
        if (classEntity.allMochaEntityList) {
            allMochaEntityList = allMochaEntityList.concat(classEntity.allMochaEntityList);
        }
    });

    dataBase.allMochaEntityList = allMochaEntityList;
})();
//</editor-fold>

//<editor-fold desc="dataBase.allDemoEntityList">
(function () {
    var allDemoEntityList = [];
    _.each(dataBase.classEntityList, function (classEntity) {
        if (classEntity.allDemoEntityList) {
            allDemoEntityList = allDemoEntityList.concat(classEntity.allDemoEntityList);
        }
    });

    dataBase.allDemoEntityList = allDemoEntityList;
})();
//</editor-fold>

//<editor-fold desc="dataBase.allRunMochaEntityList">
dataBase.allRunMochaEntityList = _.chain(dataBase.classEntityList)
    .map(function (m) {
        return m.runMochaEntityList;
    })
    .flatten()
    .compact()
    .value()
;
//</editor-fold>