var appModule = angular.module('starter', [
    'AngularNL',
    'duScroll',
    'pageslide-directive',
    'ui.router',
    'ui.codemirror',
    'starter.controllers',
    'starter.services',
    'starter.filters',
    'starter.directives'
]);

appModule.config(['$stateProvider', '$urlRouterProvider', function ($stateProvider, $urlRouterProvider) {
    $urlRouterProvider.otherwise('/class/');
}]);

appModule.run(['$rootScope', '$location', '$urlRouter', function ($rootScope, $location, $urlRouter) {
    $rootScope.uiCodeMirrorOption = {
        lineNumbers: true,
        theme: 'abcdef',
        readOnly: true,
        lineWrapping: true,
        mode: 'javascript',
        viewportMargin: Infinity
    };

    $rootScope.config = NL.Config;

    $rootScope.dataBase = window.dataBase;
}]);
// appModule.run(['$ionicPlatform', '$ionicLoading', '$rootScope',
//     function ($ionicPlatform, $ionicLoading, $rootScope) {
//         //<editor-fold desc=" $ionicPlatform.ready">
//         $ionicPlatform.ready(function () {
//             // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
//             // for form inputs)
//             if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
//                 window.cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
//             }
//             if (window.StatusBar) {
//                 // org.apache.cordova.statusbar required
//                 window.StatusBar.styleLightContent();
//             }
//         });
//         //</editor-fold>
//     }]);
//
// appModule.config(['$stateProvider', '$urlRouterProvider', '$ionicConfigProvider', '$httpProvider', function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $httpProvider) {
//
//     //<editor-fold desc="解决在android设备上，导航显示在顶部的问题">
//     $ionicConfigProvider.platform.ios.tabs.style('standard');
//     $ionicConfigProvider.platform.ios.tabs.position('bottom');
//     $ionicConfigProvider.platform.android.tabs.style('standard');
//     $ionicConfigProvider.platform.android.tabs.position('standard');
//
//     $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
//     $ionicConfigProvider.platform.android.navBar.alignTitle('left');
//
//     $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
//     $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');
//
//     $ionicConfigProvider.platform.ios.views.transition('ios');
//     $ionicConfigProvider.platform.android.views.transition('android');
//     //</editor-fold>
//
//     //<editor-fold desc="设置返回按钮不显示上一个页面的title">
//     $ionicConfigProvider.backButton.text('');
//     $ionicConfigProvider.backButton.previousTitleText(false);
//     //</editor-fold>
//
//     //<editor-fold desc="禁用js滚动">
//     $ionicConfigProvider.scrolling.jsScrolling(false);
//     //</editor-fold>
// }]);

var controllersModule = angular.module('starter.controllers', []);
var servicesModule = angular.module('starter.services', []);
var filtersModule = angular.module('starter.filters', []);
var directivesModule = angular.module('starter.directives', []);
appModule.config(['$stateProvider', 'nlProviderProvider', function ($stateProvider, nlProviderProvider) {
    $stateProvider.state('class', {
        url: '/class/:classId',
        views: {
            'view-class': {
                templateUrl: function () {
                    return nlProviderProvider.getViewTemplateUrl('src/demo/class/class-controller.html');
                },
                controller: 'class-controller'
            }
        }
    });
}]);

controllersModule.controller('class-controller', ['$scope', '$stateParams', '$window', '$location', 'commonService', function ($scope, $stateParams, $window, $location, commonService) {
    $scope.checked = false;

    $scope.data = {};
    $scope.data.classEntity = {};

    var classId = $stateParams.classId;
    if (!classId) {
        return;
    }

    var classEntity = _.find(window.dataBase.classEntityList, function (m) {
        return m.classId === classId;
    });
    if (!classEntity) {
        return;
    }
    commonService.setCurrentClassEntity(classEntity);
    window.currentClassEntity = classEntity;

    var process_hash = function () {
        var anchor = $location.hash();
        if (anchor) {
            commonService.navigateToAnchor({
                anchor: anchor,
                delay: 500
            });
        }
    };
    process_hash();

    $scope.data.classEntity = classEntity;

    $scope.btn_nav_to_class_method_click = function (pMethodEntity) {
        commonService.navigateToAnchor({
            anchor: pMethodEntity.anchor.data.anchor
        });
    };

    $scope.btn_nav_to_class_property_click = function (pPropertyEntity) {
        commonService.navigateToAnchor({
            anchor: pPropertyEntity.anchor.data.anchor
        });
    };

    $scope.btn_run_code_click = function (pDemoEntity) {
        var path = pDemoEntity.path;
        path = encodeURIComponent(path);

        $window.open('assets/run-code.html?type=002&path=' + path, '');
    };

    $scope.btn_edit_code_click = function (pDemoEntity) {
        var code = pDemoEntity.code;
        code = '<!--edit-code -->' + code;
        $window.open('assets/edit-code.html', code);
    };

    $scope.btn_run_mocha_click = function (pClassEntity) {
        var name = pClassEntity.name;
        var _name = encodeURIComponent(name);

        $window.open('assets/run-code.html?type=003&classEntityName=' + _name, '');
    };

    $scope.btn_go_to_top_click = function () {
        commonService.navigateToTop();
    };
}]);
directivesModule.directive('demoHeader', ['$compile', '$window', function ($compile, $window) {
    return {
        restrict: 'E',
        templateUrl: 'src/demo/directive/demo-header.html',
        scope: {},
        link: function ($scope, element, attrs) {
            $scope.config = NL.Config;
            $scope.dataBase = window.dataBase;

            $scope.btn_run_mocha_click = function () {
                $window.open('assets/run-code.html?type=001', '');
            };
        }
    };
}]);
directivesModule.directive('leftSlideMenu', ['$compile', '$location', function ($compile, $location) {
    return {
        restrict: 'E',
        templateUrl: 'src/demo/directive/left-slide-menu.html',
        scope: {},
        link: function ($scope, element, attrs) {
            $scope.config = NL.Config;
            $scope.data = {
                moduleEntityList: [],
                classEntityFilterKey: ''
            };

            var dataBind_moduleEntityList = function () {

                var key = $scope.data.classEntityFilterKey;

                const moduleEntityList = _.chain(window.dataBase.classEntityList)
                    .uniq(function (m) {
                        return m.module;
                    })
                    .map(function (m) {
                        const module = m.module;
                        const classEntityList = _.chain(window.dataBase.classEntityList)
                            .filter(function (classEntity) {
                                var flag = classEntity.module === module;

                                if (key) {
                                    flag = flag && classEntity.name.toLowerCase().indexOf(key.toLowerCase()) > -1;
                                }

                                return flag;
                            })
                            .value()
                        ;

                        const o = {};
                        o.name = module;
                        o.classEntityList = classEntityList;
                        return o;
                    })
                    .value()
                ;

                $scope.data.moduleEntityList = moduleEntityList;
            };

            dataBind_moduleEntityList();

            $scope.btn_toggle_menu_click = function () {
                NL.Config.ui.leftSlideMenu.isShow = !NL.Config.ui.leftSlideMenu.isShow;
            };

            $scope.input_keyUp_eventHandler = function ($event) {
                dataBind_moduleEntityList();
            };

            $scope.input_keyDown_eventHandler = function ($event) {
                if ($event.keyCode === 13) {
                    if ($scope.data.classEntityList.length > 0) {
                        var firstClassEntity = $scope.data.classEntityList[0];
                        var url = NL.Common.String.format('/class/{0}', firstClassEntity.name);
                        $location.url(url);
                    }
                }
            };

            $scope.btn_clear_classEntityFilterKey_click = function () {
                $scope.data.classEntityFilterKey = '';
                dataBind_moduleEntityList();
            };
        }
    };
}]);
directivesModule.directive('rightSlideMenu', ['$injector', 'commonService', function ($injector, commonService) {
    return {
        restrict: 'E',
        templateUrl: 'src/demo/directive/right-slide-menu.html',
        scope: {},
        link: function ($scope, element, attrs) {
            $scope.config = NL.Config;
            $scope.data = {};
            $scope.data.currentClassEntity = null;

            $scope.navigateToAnchor = function (pEntity) {
                commonService.navigateToAnchor({
                    anchor: pEntity.anchor
                });
            };

            $scope.btn_toggle_menu_click = function () {
                NL.Config.ui.rightSlideMenu.isShow = !NL.Config.ui.rightSlideMenu.isShow;
            };

            $scope.$watch('config.ui.rightSlideMenu.isShow', function (newValue, oldValue) {
                var currentClassEntity = commonService.getCurrentClassEntity();
                if (!currentClassEntity) {
                    return;
                }
                $scope.data.currentClassEntity = currentClassEntity;
                window.currentClassEntity = currentClassEntity;
            });
        }
    };
}]);
directivesModule.directive('ngBindHtmlUnsafe', ['$sce', function ($sce) {
    return {
        scope: {
            ngBindHtmlUnsafe: '=',
        },
        template: '<span ng-bind-html="trustedHtml"></span>',
        link: function ($scope, iElm, iAttrs, controller) {
            $scope.updateView = function () {
                $scope.trustedHtml = $sce.trustAsHtml($scope.ngBindHtmlUnsafe);
            };

            $scope.$watch('ngBindHtmlUnsafe', function (newVal, oldVal) {
                $scope.updateView(newVal);
            });
        }
    };
}]);
servicesModule.factory('commonService', ['$q', '$timeout', '$location', '$document', function ($q, $timeout, $location, $document) {

    //<editor-fold desc="currentClassEntity">
    var currentClassEntity = null;
    var getCurrentClassEntity = function () {
        return currentClassEntity;
    };
    var setCurrentClassEntity = function (pEntity) {
        currentClassEntity = pEntity;
    };
    //</editor-fold>

    var navigateToTop = function (pParameter) {
        if (!pParameter) {
            pParameter = {};
        }

        $location.hash('');
        $document.scrollTopAnimated(0, 400);
    };

    var navigateToAnchor = function (pParameter) {
        if (!pParameter) {
            pParameter = {};
        }

        var anchor = pParameter.anchor || '';
        var delay = pParameter.delay || '0';

        var process = function () {
            $location.hash(anchor);

            var e = angular.element(document.getElementById(anchor));
            $document.scrollToElementAnimated(e, 0, 400);
        };

        if (delay <= 0) {
            process();
        } else {
            $timeout(function () {
                process();
            }, delay);
        }

    };

    var o = {};
    o.getCurrentClassEntity = getCurrentClassEntity;
    o.setCurrentClassEntity = setCurrentClassEntity;

    o.navigateToTop = navigateToTop;
    o.navigateToAnchor = navigateToAnchor;
    return o;
}
]);
