// const path = require('path');
const fs = require('fs-extra');

const extend = require('extend');
// const Q = require('q');
// const _ = require('underscore');
// const moment = require('moment');
const babel = require(`@babel/core`);

const transform = function (pParameter) {
    const defaultParameter = {};
    defaultParameter.log_babel_transform_options = false;
    defaultParameter.babel_transform_options = {
        filename: `filename`,
        babelrc: false,

        minified: true,
        comments: false,

        presets: [
            `@babel/preset-env`,
        ],
    };

    defaultParameter.type = '000';

    defaultParameter.typeParameter = {};

    defaultParameter.typeParameter[`000`] = {};
    defaultParameter.typeParameter[`000`].code = ``;

    defaultParameter.typeParameter[`100`] = {};
    defaultParameter.typeParameter[`100`].path_file = ``;

    const parameter = extend(true, {}, defaultParameter, pParameter);
    const type = parameter.type;

    const options = parameter.babel_transform_options;
    if (parameter.log_babel_transform_options) {
        console.log(JSON.stringify(options, null, 4));
    }

    const process_type_000 = function () {
        const code = parameter.typeParameter[`000`].code;

        return babel.transformSync(code, options);
    };

    const process_type_100 = function () {
        const path_file = parameter.typeParameter[`100`].path_file;
        const code = fs.readFileSync(path_file, `utf-8`);

        return babel.transformSync(code, options);
    };

    if (type === `000`) return process_type_000();
    if (type === `100`) return process_type_100();
};

module.exports = transform;

//参考
//https://babeljs.io/docs/en/options#filename
