const isObject = require(`lodash/isObject`);

/**
 * NL类库
 *
 * @module NL
 */

/**
 * 缓存操作封装类
 * <div>
 * <span class="tag margin-right">支持浏览器环境</span>
 * <span class="tag margin-right">不支持node环境</span>
 * </div>
 *
 * @class NL.cache
 * @static
 *
 */

/**
 * 移除缓存
 *
 * @method remove
 *
 * @param {object} pParameter
 * @param {string} pParameter.key 缓存key
 *
 * @demo src/cache/demo/remove.demo.js
 */

const remove = function (pParameter) {
    if (!isObject(pParameter) && arguments.length === 1) {
        pParameter = {
            key: arguments[0]
        };
    }

    const defaultParameter = {};
    defaultParameter.key = '';
    defaultParameter.type = 'LocalStorage';//LocalStorage||Cookie

    const parameter = Object.assign({}, defaultParameter, pParameter);

    switch (parameter.type) {
        case 'LocalStorage':
            global.localStorage.removeItem(parameter.key);
            break;

        case 'Cookie':
            console.error(`还未实现！`);
            break;
    }
};
module.exports = remove;
