// const path = require(`path`);
const child_process = require(`child_process`);
const fs = require(`fs-extra`);
const extend = require(`extend`);
// const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);

const __exec = function (pMethodName, pCommand, pOptions, pCallback) {
    const methodName = pMethodName || `exec`;

    const defaultOptions = {};
    defaultOptions.logCommand = false;
    defaultOptions.os = `windows`;
    defaultOptions.encoding = `utf-8`;
    defaultOptions.maxBuffer = 1024 * 1024 * 1024;//1G = 1024 * 1024 * 1024 * 1byte
    defaultOptions.bash = {
        path_bash: `C:\\Program Files\\Git\\bin\\bash.exe`,
        options: `-c`
    };

    const options = extend(true, {}, defaultOptions, pOptions);

    const __command = pCommand || `echo hello`;
    let command;

    const process_os_linux = function () {
        const path_bash = options.bash.path_bash;
        if (!path_bash) {
            const msg = 'process_os_linux parameter error, code=001';
            console.error(msg);
            console.trace();
            return;
        }
        if (!fs.existsSync(path_bash)) {
            const msg = 'process_os_linux parameter error, code=002';
            console.error(msg);
            console.trace();
            return;
        }
        command = `"${options.bash.path_bash}" -c "${__command}"`;
    };

    const process_os_windows = function () {
        command = __command;
    };

    switch (options.os) {
        case `linux`:
            process_os_linux();
            break;

        case `windows`:
            process_os_windows();
            break;
    }

    if (options.logCommand) {
        console.log(`running command:`);
        console.log(command);
    }

    return child_process[methodName](command, options, pCallback);
};

module.exports = __exec;
