// const path = require('path');
// const fs = require('fs-extra');
// const extend = require('extend');
// const Q = require('q');
// const _ = require('underscore');
// const moment = require('moment');

const __exec = require(`../../__exec`);

/**
 * NL类库
 *
 * @module nllib
 */


/**
 * 异步执行命令
 *
 * @class nllib/src/child_process/exec
 * @static
 *
 * @param {string} pCommand 命令字符串
 * @param {object} pOptions
 * @param {string} pOptions.logCommand 是否输出执行的命令，默认值为false
 * @param {string} pOptions.os 操作系统（linux|windows），默认值为linux
 * @param {string} pOptions.encoding 返回值编码，默认值为utf-8
 * @param {object} pOptions.bash
 * @param {object} pOptions.bash.path_bash bash路径，默认值为【C:\Program Files\Git\bin\bash.exe】
 * @param {object} pOptions.bash.options bash的options，默认值为【-c】
 * @param {function} pCallback 当进程终止时调用的回调方法，方法签名为【function(error ,stdout, stderr){}】
 * @return {object} ChildProcess对象
 *
 * @demo src/child_process/exec/1.0.0/demo/index.demo.js
 */
const exec = function (pCommand, pOptions, pCallBack) {
    return __exec('exec', pCommand, pOptions, pCallBack);
};

module.exports = exec;
