// const path = require('path');
// const fs = require('fs-extra');
// const extend = require('extend');
// const Q = require('q');
// const _ = require('underscore');
// const moment = require('moment');

const __exec = require(`../../__exec`);


/**
 * NL类库
 *
 * @module nllib
 */

/**
 * 同步执行命令
 *
 * @class nllib/src/child_process/execSync.js
 * @static
 *
 * @param {string} pCommand 命令字符串
 * @param {object} pOptions
 * @param {string} pOptions.logCommand 是否输出执行的命令，默认值为false
 * @param {string} pOptions.os 操作系统（linux|windows），默认值为linux
 * @param {string} pOptions.encoding 返回值编码，默认值为utf-8
 * @param {object} pOptions.bash
 * @param {object} pOptions.bash.path_bash bash路径，默认值为【C:\Program Files\Git\bin\bash.exe】
 * @param {object} pOptions.bash.options bash的options，默认值为【-c】
 * @return {string} 执行命令后返回的stdout
 *
 * @demo src/child_process/execSync/1.0.0/demo/index.demo.js
 */
const execSync = function (pCommand, pOptions) {
    return __exec('execSync', pCommand, pOptions);
};

module.exports = execSync;
