const child_process = require(`child_process`);

/**
 * NL类库
 *
 * @module nllib
 */

/**
 * 以同步的方式，执行指定sh文件
 *
 * @class nllib/src/child_process/exec_sync_sh_file
 * @static
 *
 * @param {object} pParameter
 *
 * @param {string} pParameter.path_bash bash文件的路径，默认值为C:\Program Files\Git\bin\bash.exe
 * @param {boolean} pParameter.path_sh_file sh文件的路径
 * @return {string} stdout，标准输出流输出的字符串
 *
 * @demo src/child_process/exec_sync_sh_file/1.0.0/demo/index.demo.js
 */
const exec_sync_sh_file = function (pParameter) {
    if (!pParameter) pParameter = {};
    const path_bash = pParameter.path_bash || `C:\\Program Files\\Git\\bin\\bash.exe`;
    const path_sh_file = pParameter.path_sh_file;

    const command = `"${path_bash}" "${path_sh_file}"`;
    const options = {
        encoding: `utf-8`,
        maxBuffer: 1024 * 1024 * 1024,//1G = 1024 * 1024 * 1024 * 1byte
    };

    return child_process.execSync(command, options);
};

module.exports = exec_sync_sh_file;
