const Q = require(`q`);
const crypto = require('crypto');

const aes_decrypt = function (pParameter) {
    if (!pParameter) pParameter = {};

    const data = pParameter.data;
    const key = pParameter.key;

    if (!data) {
        const msg = `aes_decrypt parameter error, code=001`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }
    if (!key) {
        const msg = `aes_decrypt parameter error, code=002`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    const decipher = crypto.createDecipher('aes192', key);
    let decrypted = decipher.update(data, 'hex', 'utf8');
    decrypted += decipher.final('utf8');
    return decrypted;
};

module.exports = aes_decrypt;
