const Q = require(`q`);
const crypto = require('crypto');

/**
 * NL类库
 *
 * @module nllib
 */

/**
 * aes加密
 *
 * @class nllib/src/common/aes/aes_decrypt
 * @static
 *
 * @param {object} pParameter
 * @param {string} pParameter.data 要进行解密的数据
 * @param {string} pParameter.key 原始密钥
 * @return {string} 解密后的数据
 *
 * @demo src/common/aes/aes_decrypt/1.0.1/demo/index.demo.js
 */

const aes_decrypt = function (pParameter) {
    if (!pParameter) pParameter = {};

    const data = pParameter.data;
    const key = pParameter.key;

    if (!data) {
        const msg = `aes_decrypt parameter error, code=001`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }
    if (!key) {
        const msg = `aes_decrypt parameter error, code=002`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    const decipher = crypto.createDecipher('aes-128-ecb', key);
    let decrypted = decipher.update(data, 'hex', 'utf8');
    decrypted += decipher.final('utf8');
    return decrypted;
};

module.exports = aes_decrypt;
