const Q = require(`q`);
const crypto = require('crypto');

const aes_encrypt = function (pParameter) {
    if (!pParameter) pParameter = {};

    const data = pParameter.data;
    const key = pParameter.key;

    if (!data) {
        const msg = `aes_encrypt parameter error, code=001`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }
    if (!key) {
        const msg = `aes_encrypt parameter error, code=002`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    const cipher = crypto.createCipher('aes192', key);
    let crypted = cipher.update(data, 'utf8', 'hex');
    crypted += cipher.final('hex');
    return crypted;
};

module.exports = aes_encrypt;
