const Q = require(`q`);
const crypto = require('crypto');

/**
 * NL类库
 *
 * @module nllib
 */

/**
 * aes加密
 *
 * @class nllib/src/common/aes/aes_encrypt
 * @static
 *
 * @param {object} pParameter
 * @param {string} pParameter.data 要进行加密的数据
 * @param {string} pParameter.key 原始密钥
 * @return {string} 加密后的数据
 *
 * @demo src/common/aes/aes_encrypt/1.0.1/demo/index.demo.js
 */

const aes_encrypt = function (pParameter) {
    if (!pParameter) pParameter = {};

    const data = pParameter.data;
    const key = pParameter.key;

    if (!data) {
        const msg = `aes_encrypt parameter error, code=001`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }
    if (!key) {
        const msg = `aes_encrypt parameter error, code=002`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    const cipher = crypto.createCipher('aes-128-ecb', key);
    let crypted = cipher.update(data, 'utf8', 'hex');
    crypted += cipher.final('hex');
    return crypted;
};

module.exports = aes_encrypt;
