/**
 * NL类库
 *
 * @module NL
 */

/**
 * NL.common
 *
 * @class NL.common
 * @static
 *
 */

/**
 * 判断指定字符串是否包含中文字符
 * <div>
 * <span class="tag margin-right">支持浏览器环境</span>
 * <span class="tag margin-right">支持node环境</span>
 * </div>
 *
 * @method check_is_contains_chinese_characters
 * @param {string} pValue 要进行判断的字符串
 * @return {boolean} 是否包含中文字符
 *
 * @demo src/common/demo/check_is_contains_chinese_characters.demo.js
 */
const check_is_contains_chinese_characters = function (pValue) {
    const reg = /.*[\u4e00-\u9fa5]+.*/;
    return reg.test(pValue);
};

module.exports = check_is_contains_chinese_characters;
