//<editor-fold desc="node core modules">
// const path = require('path');
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require('fs-extra');
// const extend = require('extend');
// const Q = require('q');
// const _ = require('underscore');
// const moment = require('moment');
// const URI = require('urijs');
//</editor-fold>


const isBoolean = require(`lodash/isBoolean`);
const isString = require(`lodash/isString`);


/**
 * @module nllib
 */

/**
 * 转换为boolean类型数据
 *
 * @class nllib/src/convert/to_boolean
 * @static
 * @param {object} pObject 要转换的原始数据
 * @param {object} pDefaultValue 转换失败的默认值，默认值为false
 * @return {boolean} 转换后的数据
 *
 * @demo src/convert/demo/to_boolean.demo.js
 */
const to_boolean = function (pObject, pDefaultValue) {
    const defaultValue = isBoolean(pDefaultValue) ? pDefaultValue : false;

    if (isBoolean(pObject)) {
        return pObject;
    }

    if (isString(pObject)) {
        const value_001 = pObject.trim().toLowerCase();
        if (value_001 === `true`) {
            return true;
        }
        if (value_001 === `false`) {
            return false;
        }

        return defaultValue;
    }

    return defaultValue;
};

module.exports = to_boolean;
