// const path = require(`path`);
// const fs = require(`fs-extra`);
const extend = require(`extend`);
// const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);

const isString = require(`lodash/isString`);

/**
 * @module nllib
 */

/**
 * 转换为string类型数据
 *
 * @class nllib/src/convert/to_string
 * @static
 * @param {object} pObject 要转换的原始数据
 * @param {object} pDefaultValue 转换失败的默认值，默认值为``
 * @return {string} 转换后的数据
 *
 * @demo src/convert/demo/to_string.demo.js
 */
const to_string = function (pObject, pDefaultValue) {
    const defaultValue = isString(pDefaultValue) ? pDefaultValue : ``;

    if (pObject === null) return defaultValue;
    if (pObject === undefined) return defaultValue;
    return pObject.toString();
};

module.exports = to_string;
