const dict = require(`../dict`);

/**
 * NL类库
 *
 * @module NL
 */

/**
 * 字典-环境
 * <div>
 * <span class="tag margin-right">支持浏览器环境</span>
 * <span class="tag margin-right">支持node环境</span>
 * </div>
 *
 * @class NL.dicts.dict_environment
 * @static
 *
 * @demo src/dicts/demo/dict_environment.demo.js
 *
 */
const dict_environment = new dict({
    initType: `000`,
    initParameter: {
        '000': {
            entityDefine: {
                text: `text`,
                value: `value`
            },
            entityList: [
                {
                    text: `alpha`,
                    value: `alpha`,
                    remarks: `alpha`,
                },
                {
                    text: `beta`,
                    value: `beta`,
                    remarks: `beta`,
                },
                {
                    text: `release`,
                    value: `release`,
                    remarks: `release`,
                },
            ]
        }
    }
});

module.exports = dict_environment;