const path = require(`path`);
const fs = require(`fs-extra`);

const extend = require(`extend`);
const Q = require(`q`);
const _ = require(`underscore`);
const moment = require(`moment`);

const XLSX = require('xlsx');

const build_excel_file = function (pParameter) {
    if (!pParameter) pParameter = {};
    const entity_list = pParameter.entity_list || [];
    const path_file_excel = pParameter.path_file_excel || `${moment().format('YYYY-MM-DD-HHmmss')}.xls`;
    const sheetName = pParameter.sheetName || `main`;

    const path_directory = path.dirname(path_file_excel);
    const path_init_directory_md = path.join(path_directory, `init_directory.md`);
    fs.outputFileSync(path_init_directory_md, `# init_directory.md`);

    const data_file_workbook = {
        SheetNames: [],
        Sheets: {}
    };

    const workbook = data_file_workbook;
    const query = _.find(workbook.SheetNames, function (m) {
        return m === sheetName;
    });
    if (!query) {
        workbook.SheetNames.push(sheetName);
        workbook.Sheets[sheetName] = [];
    }

    workbook.Sheets[sheetName] = XLSX.utils.json_to_sheet(entity_list);

    XLSX.writeFile(data_file_workbook, path_file_excel);
    console.log(`文件创建成功：${path_file_excel}`);
};

module.exports = build_excel_file;
