//参考自：https://www.jianshu.com/p/e2cd2cb28ba9

//将excel的日期格式转成Date()对象;

// function getFormatDate_XLSX(serial) {
//     var utc_days = Math.floor(serial - 25569);
//     var utc_value = utc_days * 86400;
//     var date_info = new Date(utc_value * 1000);
//     var fractional_day = serial - Math.floor(serial) + 0.0000001;
//     var total_seconds = Math.floor(86400 * fractional_day);
//     var seconds = total_seconds % 60;
//     total_seconds -= seconds;
//     var hours = Math.floor(total_seconds / (60 * 60));
//     var minutes = Math.floor(total_seconds / 60) % 60;
//     var d = new Date(date_info.getFullYear(), date_info.getMonth(), date_info.getDate(), hours, minutes, seconds);
//     /*//得到Date()对象后，便可进行日期格式化了！
//     var add0 = (m) => m < 10 ? '0' + m : m;
//     var d = getFormatDate_XLSX(44358.9999884259);
//     var YYYY = d.getFullYear();
//     var MM = add0(d.getMonth() + 1);
//     var DD = add0(d.getDate());
//     var hh = add0(d.getHours());
//     var mm = add0(d.getMinutes());
//     var ss = add0(d.getSeconds());
//     return `${YYYY}-${MM}-${DD} ${hh}:${mm}:${ss}`;
//     */
//     return d;
// }

/**
 * @module nllib
 */

/**
 * 将通过XLSX.utils.sheet_to_json方法返回的日期时间的数据，转换成js的date对象
 *
 * @class nllib/src/excel-helper/get_js_date_object_from_xlsx_date_data
 * @static
 * @param {object} pParameter
 * @param {number} pParameter.serial XLSX.utils.sheet_to_json方法返回的日期时间的数据
 *
 * @return {object} js的date对象
 *
 * @demo src/excel-helper/get_js_date_object_from_xlsx_date_data/1.0.0/demo/index.demo.js
 */
const get_js_date_object_from_xlsx_date_data = function (pParameter) {
    if (!pParameter) pParameter = {};
    const serial = pParameter.serial;

    var utc_days = Math.floor(serial - 25569);
    var utc_value = utc_days * 86400;
    var date_info = new Date(utc_value * 1000);
    var fractional_day = serial - Math.floor(serial) + 0.0000001;
    var total_seconds = Math.floor(86400 * fractional_day);
    var seconds = total_seconds % 60;
    total_seconds -= seconds;
    var hours = Math.floor(total_seconds / (60 * 60));
    var minutes = Math.floor(total_seconds / 60) % 60;
    var d = new Date(date_info.getFullYear(), date_info.getMonth(), date_info.getDate(), hours, minutes, seconds);
    /*//得到Date()对象后，便可进行日期格式化了！
    var add0 = (m) => m < 10 ? '0' + m : m;
    var d = getFormatDate_XLSX(44358.9999884259);
    var YYYY = d.getFullYear();
    var MM = add0(d.getMonth() + 1);
    var DD = add0(d.getDate());
    var hh = add0(d.getHours());
    var mm = add0(d.getMinutes());
    var ss = add0(d.getSeconds());
    return `${YYYY}-${MM}-${DD} ${hh}:${mm}:${ss}`;
    */
    return d;
};

module.exports = get_js_date_object_from_xlsx_date_data;
