// const path = require(`path`);
const fs = require(`fs-extra`);
// const extend = require(`extend`);
const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);
const XLSX = require('xlsx');

// const to_boolean = require(`../../../convert/to_boolean`);

const read_excel_file = function (pParameter) {
    if (!pParameter) pParameter = {};
    const path_file_excel = pParameter.path_file_excel;
    const sheetName_001 = pParameter.sheetName;

    if (!fs.existsSync(path_file_excel)) {
        const msg = `read_excel_file parameter error, code=001`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    const aWorkBook = XLSX.readFile(path_file_excel, {});
    const aSheetNames = aWorkBook.SheetNames;
    if (aSheetNames.length <= 0) {
        const msg = `read_excel_file parameter error, code=002`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    const sheetName_002 = sheetName_001 ? sheetName_001 : aSheetNames[0];
    const aWorkSheet = aWorkBook.Sheets[sheetName_002];
    if (!aWorkSheet) {
        const msg = `read_excel_file parameter error, code=003`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    const jsa = XLSX.utils.sheet_to_json(aWorkSheet, {
        // header: 1,
        // header: `A`,
    });
    return jsa;
};

module.exports = read_excel_file;
