//<editor-fold desc="node core modules">
// const path = require('path');
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require('fs-extra');
// const extend = require('extend');
// const Q = require('q');
// const _ = require('underscore');
// const moment = require('moment');
// const URI = require('urijs');
//</editor-fold>

//----------------------------------------------------------------------------------------------------------------------
const cache = {};
cache.get = require(`./cache/get`);
cache.remove = require(`./cache/remove`);
cache.set = require(`./cache/set`);

//----------------------------------------------------------------------------------------------------------------------
const common = {};
common.check_is_contains_chinese_characters = require(`./common/check_is_contains_chinese_characters`);
common.delete_object_property = require(`./common/delete_object_property`);
common.get_uuid = require(`./common/get_uuid`);
common.wait_some_seconds = require(`./common/wait_some_seconds`);

//----------------------------------------------------------------------------------------------------------------------
const convert = {};
convert.is_boolean = require(`./convert/is_boolean`);
convert.is_bool = require(`./convert/is_boolean`);
convert.to_boolean = require(`./convert/to_boolean`);
convert.to_bool = require(`./convert/to_boolean`);
convert.is_int = require(`./convert/is_int`);
convert.to_int = require(`./convert/to_int`);
convert.to_lower_case_property_name_object = require(`./convert/to_lower_case_property_name_object`);

//----------------------------------------------------------------------------------------------------------------------
const dict = require(`./dict`);

//----------------------------------------------------------------------------------------------------------------------
const dicts = {};
dicts.dict_cache_key = require(`./dicts/dict_cache_key`);
dicts.dict_environment = require(`./dicts/dict_environment`);

//----------------------------------------------------------------------------------------------------------------------
const file = {};
file.file_to_data_url = require(`./file/file_to_data_url`);
file.file_to_text = require(`./file/file_to_text`);
file.quickly_create_file = require(`./file/quickly_create_file`);

//----------------------------------------------------------------------------------------------------------------------
const iframeHelper = require(`./iframe-helper`);

//----------------------------------------------------------------------------------------------------------------------
const json = {};
json.to_json = require(`./json/to_json`);
json.to_object = require(`./json/to_object`);

//----------------------------------------------------------------------------------------------------------------------
const model = {};
model.get_environment = require(`./model/get_environment`);
model.get_token = require(`./model/get_token`);
model.global_config = require(`./model/global_config`);
model.remove_environment = require(`./model/remove_environment`);
model.remove_token = require(`./model/remove_token`);
model.request_webApiType_v2 = require(`./model/request_webApiType_v2`);
model.set_environment = require(`./model/set_environment`);
model.set_token = require(`./model/set_token`);

//----------------------------------------------------------------------------------------------------------------------
const promiseHelper = {};
promiseHelper.wrap_cache = require(`./promise-helper/wrap_cache`);

//----------------------------------------------------------------------------------------------------------------------
const systemDocking = {};

systemDocking.aliyun = {};
systemDocking.aliyun.oss = {};
systemDocking.aliyun.oss.frontend = {};
systemDocking.aliyun.oss.frontend.client = require(`./system-docking/aliyun/oss/frontend/client`);

systemDocking.qyh = {};
systemDocking.qyh.frontend = {};
systemDocking.qyh.frontend.webBase_api_sso_loginBySecurityAsync = require(`./system-docking/qyh/frontend/webBase_api_sso_loginBySecurityAsync`);
systemDocking.qyh.frontend.webBase_api_v2_user_getUserClassList = require(`./system-docking/qyh/frontend/webBase_api_v2_user_getUserClassList`);

systemDocking.sso = {};
// systemDocking.sso.backend = {};
// systemDocking.sso.backend.get_token = require(`./system-docking/sso/backend/get_token`);
systemDocking.sso.frontend = {};
systemDocking.sso.frontend.redirectHelper = require(`./system-docking/sso/frontend/redirectHelper`);
systemDocking.sso.frontend.__api_v1_dept_getClassList = require(`./system-docking/sso/frontend/__api_v1_dept_getClassList`);
systemDocking.sso.frontend.__api_v1_user_getUserInfo = require(`./system-docking/sso/frontend/__api_v1_user_getUserInfo`);
systemDocking.sso.frontend.__get_sso_config = require(`./system-docking/sso/frontend/__get_sso_config`);
systemDocking.sso.frontend.__get_token = require(`./system-docking/sso/frontend/__get_token`);
systemDocking.sso.frontend.__v1_sso_login_jsonp = require(`./system-docking/sso/frontend/__v1_sso_login_jsonp`);
systemDocking.sso.frontend.__v1_sso_selectUser_jsonp = require(`./system-docking/sso/frontend/__v1_sso_selectUser_jsonp`);
systemDocking.sso.frontend.__v2_oauth_token_get = require(`./system-docking/sso/frontend/__v2_oauth_token_get`);


//----------------------------------------------------------------------------------------------------------------------
const uri = {};
uri.get_platform_information = require(`./uri/get_platform_information`);
uri.get_query_string_object = require(`./uri/get_query_string_object`);
uri.join = require(`./uri/join`);

//----------------------------------------------------------------------------------------------------------------------
const Aliyun = {};
Aliyun.Oss = {};
Aliyun.Oss.Client = function (pParameter) {
    console.warn(`NL.Aliyun.Oss.Client is deprecated! Please use NL.systemDocking.aliyun.oss.frontend.client instead!`);
    return new systemDocking.aliyun.oss.frontend.client(pParameter);
};

const Common = {};

Common.Cache = {};
Common.Cache.get = function () {
    console.warn(`NL.Common.Cache.get is deprecated! Please use NL.cache.get instead!`);
    const func = cache.get;
    return func.apply(null, Array.prototype.slice.call(arguments));
};
Common.Cache.set = function () {
    console.warn(`NL.Common.Cache.set is deprecated! Please use NL.cache.set instead!`);
    const func = cache.set;
    return func.apply(null, Array.prototype.slice.call(arguments));
};
Common.Cache.deleteCache = function () {
    console.warn(`NL.Common.Cache.deleteCache is deprecated! Please use NL.cache.remove instead!`);
    const func = cache.remove;
    return func.apply(null, Array.prototype.slice.call(arguments));
};

Common.Convert = {};
Common.Convert.toInt = function () {
    console.warn(`NL.Common.Convert.toInt is deprecated! Please use NL.convert.to_int instead!`);
    const func = convert.to_int;
    return func.apply(null, Array.prototype.slice.call(arguments));
};
Common.Convert.toBool = function () {
    console.warn(`NL.Common.Convert.toBool is deprecated! Please use NL.convert.to_bool instead!`);
    const func = convert.to_bool;
    return func.apply(null, Array.prototype.slice.call(arguments));
};

Common.IFrameHelper = (function () {
    const o = {};
    o.init = function () {
        console.warn(`NL.Common.IFrameHelper.init is deprecated! Please use NL.iframeHelper.init instead!`);
        const func = iframeHelper.init;
        return func.apply(null, Array.prototype.slice.call(arguments));
    };
    o.postMessage = function () {
        console.warn(`NL.Common.IFrameHelper.postMessage is deprecated! Please use NL.iframeHelper.postMessage instead!`);
        const func = iframeHelper.postMessage;
        return func.apply(null, Array.prototype.slice.call(arguments));
    };
    o.on = function () {
        console.warn(`NL.Common.IFrameHelper.on is deprecated! Please use NL.iframeHelper.on instead!`);
        const func = iframeHelper.on;
        return func.apply(null, Array.prototype.slice.call(arguments));
    };
    o.createIFrame = function () {
        console.warn(`NL.Common.IFrameHelper.createIFrame is deprecated! Please use NL.iframeHelper.createIFrame instead!`);
        const func = iframeHelper.createIFrame;
        return func.apply(null, Array.prototype.slice.call(arguments));
    };
    return o;
})();

Common.Json = {};
Common.Json.toJson = function () {
    console.warn(`NL.Common.Json.toJson is deprecated! Please use NL.json.to_json instead!`);
    const func = json.to_json;
    return func.apply(null, Array.prototype.slice.call(arguments));
};
Common.Json.toObject = function () {
    console.warn(`NL.Common.Json.toObject is deprecated! Please use NL.json.to_object instead!`);
    const func = json.to_object;
    return func.apply(null, Array.prototype.slice.call(arguments));
};

Common.Other = {};
Common.Other.getUUID = function () {
    console.warn(`NL.Common.Other.getUUID is deprecated! Please use NL.common.get_uuid instead!`);
    const func = common.get_uuid;
    return func.apply(null, Array.prototype.slice.call(arguments));
};

Common.RedirectHelper = function (pParameter) {
    console.warn(`NL.Common.RedirectHelper is deprecated! Please use NL.systemDocking.sso.frontend.redirectHelper instead!`);
    return new systemDocking.sso.frontend.redirectHelper(pParameter);
};

Common.Url = {};
Common.Url.join = function () {
    console.warn(`NL.Common.Other.join is deprecated! Please use NL.uri.join instead!`);
    const func = uri.join;
    return func.apply(null, Array.prototype.slice.call(arguments));
};
Common.Url.getQueryStringObject = function () {
    console.warn(`NL.Common.Other.getQueryStringObject is deprecated! Please use NL.uri.get_query_string_object instead!`);
    const func = uri.get_query_string_object;
    return func.apply(null, Array.prototype.slice.call(arguments));
};
Common.Url.getSituationType = function () {
    console.warn(`NL.Common.Other.getSituationType is deprecated! Please find leiyining to discuss a new solution!`);
    const func = require(`./uri/get_situation_type`);
    return func.apply(null, Array.prototype.slice.call(arguments));
};

const MVC = {};
MVC.Model = function () {
    console.warn(`NL.MVC.Model is deprecated! Please find leiyining to discuss a new solution!`);
};

const v2Model = {};
v2Model.setEnvironment = function () {
    console.warn(`NL.v2Model.setEnvironment is deprecated! Please use NL.model.set_environment instead!`);
    const func = model.set_environment;
    return func.apply(null, Array.prototype.slice.call(arguments));
};
v2Model.setToken = function () {
    console.warn(`NL.v2Model.setToken is deprecated! Please use NL.model.set_token instead!`);
    const func = model.set_token;
    return func.apply(null, Array.prototype.slice.call(arguments));
};


//----------------------------------------------------------------------------------------------------------------------
module.exports = {
    cache,
    common,
    convert,
    dict,
    dicts,
    file,
    iframeHelper,
    json,
    model,
    promiseHelper,
    systemDocking,
    uri,

    //------------------------------------------------------------------------------------------------------------------
    Aliyun,
    Common,
    MVC,
    v2Model,
};



