/**
 * NL类库
 *
 * @module nllib
 */


/**
 * 获取方法分析数据
 *
 * @class nllib/src/js-code-analyze/get_function_analyze_data
 * @static
 *
 * @param {object} pParameter
 * @param {function} pParameter.fn 方法
 * @return {object} 数据
 *
 * @demo src/js-code-analyze/get_function_analyze_data/1.0.0/demo/index.demo.js
 */

const get_function_analyze_data = function (pParameter) {
    if (!pParameter) pParameter = {};
    const fn = pParameter.fn;

    let function_to_string = ``;
    let function_name = ``;
    let function_body_code = ``;
    let function_body_code_row_list_001 = [];
    let function_body_code_row_list_002 = [];

    if (typeof fn !== `function`) {
        const msg = `get_function_analyze_data parameter error, code=001`;
        console.error(msg);
        console.trace();
        return {
            function_to_string,
            function_name,
            function_body_code,
            function_body_code_row_list_001,
            function_body_code_row_list_002,
        };
    }

    const reg = /^function (.*?)\(\) {([\s\S]*)}$/g;

    function_to_string = fn.toString();

    const result = reg.exec(function_to_string);
    // console.log(JSON.stringify(result, null, 4));
    if (result) {
        if (result.length >= 3) {
            function_name = result[1];
            function_body_code = result[2];
        }
    }
    // console.log(function_body_code);

    function_body_code_row_list_001 = function_body_code.split(/\n/gi);
    // console.log(JSON.stringify(function_body_code_row_list_001, null, 4));

    for (let i = 0; i < function_body_code_row_list_001.length; i++) {
        const s_001 = function_body_code_row_list_001[i];
        const reg = /\/\/.*$/gi;
        if (!reg.test(s_001)) {
            const s_002 = s_001
                .replace(/\n/gi, ``)
                .replace(/\r/gi, ``)
            ;
            function_body_code_row_list_002.push(s_002);
        }
    }

    return {
        function_to_string,
        function_name,
        function_body_code,
        function_body_code_row_list_001,
        function_body_code_row_list_002,
    };
};

module.exports = get_function_analyze_data;
