//<editor-fold desc="node core modules">
const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
const fs = require(`fs-extra`);
const extend = require(`extend`);
// const Q = require(`q`);
const _ = require(`underscore`);
const moment = require(`moment`);
// const URI = require(`urijs`);
const ejs = require(`ejs`);
const Y = require(`yuidocjs`);
//</editor-fold>

// console.log(`__dirname=${__dirname}`);
// console.log(`__filename=${__filename}`);
// console.log(`process.cwd()=${process.cwd()}`);
// console.log(`require.main.filename=${require.main.filename}`);

const dict = require(`../dict`);
const __get_path_info = require(`../common/__get_path_info`);
const get_uuid = require(`../common/get_uuid`);
// const __path = require(`../path`);
const to_object = require(`../json/to_object`);
const to_json = require(`../json/to_json`);

const dict_jsDocBuilder_init_type = new dict({
    initType: '000',
    initParameter: {
        '000': {
            entityDefine: {
                text: 'text',
                value: 'value'
            },
            entityList: [
                {
                    text: 'scanning-path',
                    value: 'scanning-path',
                    remarks: '扫描路径'
                },
                {
                    text: 'scanning-file',
                    value: 'scanning-file',
                    remarks: '扫描路径'
                },
            ]
        }
    }
});

const jsDocBuilder = function jsDocBuilder(pInitParameter) {
    const _this = this;

    const defaultInitParameter = {};

    defaultInitParameter.work_dir = `./node_modules/nllib`;
    defaultInitParameter.type = dict_jsDocBuilder_init_type.map[`scanning-path`];//scanning-path

    defaultInitParameter.typeParameter = {};

    defaultInitParameter.typeParameter[`scanning-path`] = {};
    defaultInitParameter.typeParameter[`scanning-path`].paths = [];

    defaultInitParameter.typeParameter[`scanning-file`] = {};
    defaultInitParameter.typeParameter[`scanning-file`].path = ``;

    defaultInitParameter.outdir = ``;
    defaultInitParameter.demo = {
        basePath: `./`,
        link: null,
        fileListToCopy: null,
        process_fromSourceCode: null
    };
    defaultInitParameter.project = {
        name: `api document`,
        description: {
            text01: `api document`,
            text02: `Use the left menu to navigate to the class which you want to learn about its api.`
        },
        navList: [
            {title: `home`, url: `#/class/`, active: true},
            {title: `other`, url: ``, active: false},
        ]
    };

    const initParameter = extend(true, {}, defaultInitParameter, pInitParameter);

    const __work_dir = initParameter.work_dir;
    const work_dir = path.resolve(__work_dir);
    const path_assets = path.join(work_dir, `assets/nllib/src/jsDocBuilder/assets`);
    const path_document_template = path.join(path_assets, `document_template`);

    console.log(`__work_dir=${__work_dir}`);
    console.log(`work_dir=${work_dir}`);
    console.log(`path_assets=${path_assets}`);
    console.log(`path_document_template=${path_document_template}`);

    const type = initParameter.type;

    const path_info = __get_path_info();
    const path_temp = path_info.path_temp;
    console.log(`目录清空开始 ===> 【${path_temp}】`);
    fs.removeSync(path_temp);
    console.log(`目录清空结束 ===> 【${path_temp}】`);

    const extendYUI = function () {
        Y.DocParser.TAGLIST.push(`demo`);
        Y.DocParser.DIGESTERS.demo = function (tagName, value, target) {
            // console.log(`value=`);
            // console.log(value);

            if (!target.demoEntityList) {
                target.demoEntityList = [];
            }

            if (!value) {
                return;
            }

            const get_value_analysis_result = function () {
                const reg = /(.*?)\s*({.*})/gi;
                const result = reg.exec(value);
                // console.log(`result=`);
                // console.log(result);
                // if (result) {
                //     console.log(`result.length=${result.length}`);
                // }

                let parameter_type;
                if (result && result.length >= 3) {
                    parameter_type = `100`;
                } else {
                    parameter_type = `000`;
                }

                let _path;
                let option;

                const defaultOption = {};
                defaultOption.buildType = `000`;

                switch (parameter_type) {
                    case `000`:
                        _path = value;
                        option = extend(true, {}, defaultOption);
                        break;

                    case `100`:
                        _path = result[1];
                        option = extend(true, {}, defaultOption, to_object(result[2]));
                        // console.log(`result[2]=`);
                        // console.log(result[2]);
                        break;
                }

                const o = {};
                o.parameter_type = parameter_type;
                o.path = _path;
                o.option = option;
                return o;
            };

            const value_analysis_result = get_value_analysis_result();

            const get_demo_entity = function () {

                const _path = value_analysis_result.path;
                const option = value_analysis_result.option;

                let title;
                let code;

                title = path.basename(_path);

                const __path_002 = path.join(initParameter.demo.basePath, _path);
                try {
                    code = fs.readFileSync(__path_002, `utf-8`);
                } catch (err) {
                    console.error(`分析demo标签时，文件读取失败：${err}`);
                }

                const o = {};
                o.title = title;
                o.code = code;
                o.path = _path;
                o.option = option;
                return o;
            };

            const demoEntityList = target.demoEntityList;
            const demoEntity = get_demo_entity();
            demoEntityList.push(demoEntity);

            // console.log(`demoEntity=`);
            // console.log(JSON.stringify(demoEntity, null, 4));
        };
    };
    extendYUI();

    const build = function () {
        const init_directory = function () {
            console.log(`目录初始化开始 ===> 【${initParameter.outdir}】`);
            fs.removeSync(initParameter.outdir);
            fs.mkdirsSync(initParameter.outdir);
            console.log(`目录初始化开始 ===> 【${initParameter.outdir}】`);

            console.log(`目录初始化开始 ===> 【${path_temp}】`);
            fs.removeSync(path_temp);
            fs.mkdirsSync(path_temp);
            console.log(`目录初始化开始 ===> 【${path_temp}】`);
        };
        init_directory();

        const now = moment();

        const nlVersion = now.format(`YYYYMMddHHmmss`);
        const nlVersionForQueryString = `nlVersion=${nlVersion}}`;

        const __copySingleFile = function (pSrc, pDest) {
            const content_001 = fs.readFileSync(pSrc, `utf-8`);
            const content_002 = content_001
                .replace(/%nlVersion%/gi, nlVersion)
                .replace(/%nlVersionForQueryString%/gi, nlVersionForQueryString)
                .replace(/%nllib-version%/gi, `1.1.50`);

            console.log(`文件构建开始 ===> ${pSrc} ===> ${pDest}`);
            fs.outputFileSync(pDest, content_002);
            console.log(`文件构建完成 ===> ${pSrc} ===> ${pDest}`);
        };

        const getEjsDataSource = function () {
            const dataSource = _.extend({}, initParameter);

            dataSource.demo.jsUrlList = _.filter(dataSource.demo.link, function (m) {
                const url = m.toLowerCase();
                let flag = false;
                if (url.endsWith(`.js`)) {
                    flag = true;
                }
                return flag;
            });

            dataSource.demo.cssUrlList = _.filter(dataSource.demo.link, function (m) {
                const url = m.toLowerCase();
                let flag = false;
                if (url.endsWith(`.css`)) {
                    flag = true;
                }
                return flag;
            });

            dataSource.demo.jsUrlList_res = [];
            _.each(initParameter.demo.fileListToCopy, function (filePath) {
                const src = filePath;
                if (!src.endsWith(`.js`)) {
                    return;
                }

                const basename = path.basename(src);
                const dest = `res/` + basename;
                dataSource.demo.jsUrlList_res.push(dest);
            });

            dataSource.demo.cssUrlList_res = [];
            _.each(initParameter.demo.fileListToCopy, function (filePath) {
                const src = filePath;
                if (!src.endsWith(`.css`)) {
                    return;
                }

                const basename = path.basename(src);
                const dest = `res/` + basename;
                dataSource.demo.cssUrlList_res.push(dest);
            });

            return dataSource;
        };
        const ejsDataSource = getEjsDataSource();

        const process_dataBase_js = function () {
            let options;

            const get_options_type_scanning_path = function () {
                const paths = initParameter.typeParameter[`scanning-path`].paths;
                const options = {
                    paths: paths,
                    outdir: initParameter.outdir,
                };
                return options;
            };

            const get_options_type_scanning_file = function () {
                const path_js_file = initParameter.typeParameter[`scanning-file`].path;
                const src = path_js_file;
                const path_dir_dest = path.join(path_temp, get_uuid());
                const path_file_name_dest = path.basename(src);
                const dest = path.join(path_dir_dest, path_file_name_dest);
                console.log(`复制文件开始 ===> ${src} ===>${dest}`);
                fs.copySync(src, dest);
                console.log(`复制文件结束 ===> ${src} ===>${dest}`);
                const paths = initParameter.typeParameter[`scanning-file`].path;
                const options = {
                    paths: paths,
                    outdir: initParameter.outdir,
                };
                return options;
            };

            switch (type) {
                case dict_jsDocBuilder_init_type.map[`scanning-path`]:
                    options = get_options_type_scanning_path();
                    break;

                case dict_jsDocBuilder_init_type.map[`scanning-file`]:
                    options = get_options_type_scanning_file();
                    break;
            }

            const dataBaseObject = (new Y.YUIDoc(options)).run();
            // console.log(JSON.stringify(dataBaseObject, null, 4));
            // console.log(`---dataBaseObject.classes=`);
            // console.log(JSON.stringify(dataBaseObject.classes, null, 4));
            // console.log(`---dataBaseObject.classitems=`);
            // console.log(JSON.stringify(dataBaseObject.classitems, null, 4));
            let dataBaseJsCode = `var dataBase = ` + to_json(dataBaseObject) + `;`;
            dataBaseJsCode += `dataBase.project=` + to_json(initParameter.project) + `;`;
            const dataBaseFilePath = path.join(initParameter.outdir, `dataBase.js`);
            fs.outputFileSync(dataBaseFilePath, dataBaseJsCode);
            console.log(`file generation success:${dataBaseFilePath}`);
        };
        const process_main = function () {
            let src = path.join(path_document_template, `dataBase.process.js`);
            let dest = path.join(initParameter.outdir, `dataBase.process.js`);
            console.log(`path_document_template=${path_document_template}`);
            console.log(`src=${src}`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `index-demo.dev.html`);
            dest = path.join(initParameter.outdir, `index.html`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `NL.Config.dev.js`);
            dest = path.join(initParameter.outdir, `NL.Config.js`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `grunt-build/dev/demo.dev.js`);
            dest = path.join(initParameter.outdir, `grunt-build/dev/demo.dev.js`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `grunt-build/pro/demo.min.css`);
            dest = path.join(initParameter.outdir, `grunt-build/pro/demo.min.css`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `src/demo/class/class-controller.html`);
            dest = path.join(initParameter.outdir, `src/demo/class/class-controller.html`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `src/demo/directive/demo-header.html`);
            dest = path.join(initParameter.outdir, `src/demo/directive/demo-header.html`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `src/demo/directive/left-slide-menu.html`);
            dest = path.join(initParameter.outdir, `src/demo/directive/left-slide-menu.html`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `src/demo/directive/right-slide-menu.html`);
            dest = path.join(initParameter.outdir, `src/demo/directive/right-slide-menu.html`);
            __copySingleFile(src, dest);
        };
        const process_assets = function () {
            let src;
            let dest;

            src = path.join(path_document_template, `assets/edit-code.css`);
            dest = path.join(initParameter.outdir, `assets/edit-code.css`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `assets/edit-code.html`);
            dest = path.join(initParameter.outdir, `assets/edit-code.html`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `assets/edit-code.js`);
            dest = path.join(initParameter.outdir, `assets/edit-code.js`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `assets/run-code.css`);
            dest = path.join(initParameter.outdir, `assets/run-code.css`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `assets/run-code.html.ejs`);
            dest = path.join(initParameter.outdir, `assets/run-code.html`);
            const template = fs.readFileSync(src, `utf-8`);
            const output = ejs.render(template, ejsDataSource);
            fs.outputFileSync(dest, output);

            src = path.join(path_document_template, `assets/run-code.js`);
            dest = path.join(initParameter.outdir, `assets/run-code.js`);
            __copySingleFile(src, dest);

            src = path.join(path_document_template, `assets/utils.js`);
            dest = path.join(initParameter.outdir, `assets/utils.js`);
            __copySingleFile(src, dest);

            _.each(initParameter.demo.fileListToCopy, function (filePath) {
                const src = filePath;
                const basename = path.basename(src);
                const dest = path.join(initParameter.outdir, `assets\\res`, basename);
                __copySingleFile(src, dest);
            });
        };
        const process_fromSourceCode = function () {
            const pathFromSourceCode = path.join(initParameter.outdir, `from-source-code`);

            if (initParameter.demo.process_fromSourceCode) {
                initParameter.demo.process_fromSourceCode({
                    initParameter: initParameter,
                    pathFromSourceCode: pathFromSourceCode
                });
            }

            console.log(`process_fromSourceCode success:`, pathFromSourceCode);
        };

        process_dataBase_js();
        process_main();
        process_assets();
        process_fromSourceCode();
    };
    _this.build = build;
};

module.exports = jsDocBuilder;