const Q = require('q');
const _ = require('underscore');
const axios = require(`axios`);

const join = require(`../uri/join`);
const get_environment = require(`./get_environment`);
const get_token = require(`./get_token`);

const request_webApiType_v2_1 = function (pParameter) {
    console.warn(`src/model/request_webApiType_v2_1.js 慢慢废弃！`);

    const defaultParameter = {};
    defaultParameter.method = 'post';//post|get
    defaultParameter.data = {};
    defaultParameter.headers = {};
    defaultParameter.timeout = 10 * 1000;
    defaultParameter.maxRedirects = 5;

    defaultParameter.app_key = `default`;
    defaultParameter.url_suffix = 'default-url-suffix';
    defaultParameter.get_environment = function () {
        return get_environment();
    };
    defaultParameter.get_token = function () {
        return get_token();
    };
    defaultParameter.get_url = function (args) {
        const __parameter = args.parameter;

        const app_key = __parameter.app_key;
        const url_suffix = __parameter.url_suffix;
        const environment = __parameter.get_environment();

        const list = [
            {app_key: `test`, url_prefix: `http://test.com`}
        ];
        const query = _.chain(list)
            .find(function (m) {
                return 1 === 1
                    && m.app_key === app_key
                    && m.environment === environment;
            })
            .value();

        if (!query) {
            let msg = 'request_webApiType_v2_1 parameter error, code=701';
            msg += `|app_key=${app_key}`;
            msg += `|url_suffix=${url_suffix}`;
            console.error(msg);
            return Q.reject({msg: msg});
        }

        const url_prefix = query.url_prefix;
        const url = join(url_prefix, url_suffix);
        return url;
    };

    const parameter = Object.assign({}, defaultParameter, pParameter);

    // const __get_environment = parameter.get_environment;
    const __get_token = parameter.get_token;

    const method = parameter.method;

    const get_url = parameter.get_url;
    const url = get_url({
        parameter: parameter,
        pParameter: pParameter,
    });

    const data = parameter.data;

    const get_headers = function () {
        const headers = Object.assign({}, parameter.headers);

        const ___token = __get_token();
        const token = headers.authorization || ___token;
        if (token) {
            headers.authorization = token;
        }

        return headers;
    };
    const headers = get_headers();

    const timeout = parameter.timeout;

    const options = {
        method: method,
        url: url,
        data: data,
        headers: headers,
        timeout: timeout,
    };

    return Q.when()
        .then(function () {
            return axios(options);
        })
        .then(function (res) {
            return Q.resolve(res.data);
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};

module.exports = request_webApiType_v2_1;
