const path = require(`path`);
const fs = require(`fs-extra`);
const moment = require(`moment`);

const to_boolean = require(`../../../convert/to_boolean`);

const init_directory = function (pParameter) {
    if (!pParameter) pParameter = {};
    const path_dir = pParameter.path_dir || path.resolve(`./`);
    const enable_log = to_boolean(pParameter.enable_log, true);

    const path_file_init_directory_md = path.join(path_dir, `init-directory.md`);

    fs.outputFileSync(path_file_init_directory_md, moment().format(`YYYY-MM-DD HH:mm:ss`));

    if (enable_log) console.log(`nllib/src/path/init_directory:`, path_file_init_directory_md);

    return {
        path_dir,
        path_file_init_directory_md,
    };
};

module.exports = init_directory;
