const path = require(`path`);

const execSync = require(`../../../child_process/execSync`);

/**
 * NL类库
 *
 * @module nllib
 */

/**
 * 打开目录
 *
 * @class nllib/src/path/open_directory
 * @static
 *
 * @param {object} pParameter
 *
 * @param {string} pParameter.path_dir 要打开的目录，默认值为path.resolve(`./`)
 *
 * @demo src/path/open_directory/1.0.0/demo/index.demo.js
 */
const open_directory = function (pParameter) {
    if (!pParameter) pParameter = {};
    const path_dir = pParameter.path_dir || path.resolve(`./`);
    const command = `explorer "${path_dir}"`;
    return execSync(command, {});
};

module.exports = open_directory;
