const Q = require(`q`);
const _ = require(`underscore`);

let cache_list = [];

const wrap_cache = function (pParameter) {
    if (!pParameter) {
        pParameter = {};
    }

    const fn = pParameter.fn || null;
    const clear_cache = pParameter.clear_cache || false;

    if (!_.isFunction(fn)) {
        const msg = 'wrap_cache parameter error, code=001';
        console.error(msg);
        return Q.reject({msg: msg});
    }

    const key = fn.toString();

    if (clear_cache) {
        cache_list = _.filter(cache_list, function (m) {
            return m.key !== key;
        });
    }

    const query = _.find(cache_list, function (m) {
        return m.key === key;
    });

    let promise;
    if (query) {
        promise = query.value;
    } else {
        promise = fn();

        cache_list.push({
            key: key,
            value: promise
        });
    }
    return promise;
};

module.exports = wrap_cache;
