const _ = require(`underscore`);

const cache = {};

const separation_line_helper = function separation_line_helper(pInitParameter) {
    const __this = this;

    const __separator = pInitParameter.separator || `-`;
    const __separator_length = pInitParameter.separator_length || 30;

    const get = function (pParameter) {
        if (!pParameter) pParameter = {};

        const separator = pParameter.separator || __separator;
        const separator_length = pParameter.separator_length || __separator_length;
        const text = pParameter.text || ``;

        const key = `${separator}-${separator_length}-${text}`;
        if (!cache[key]) {
            const text_length = text.length;

            const length_001 = separator_length - text_length;
            const length_002 = length_001 / 2;
            const length_003 = length_002 + text_length;

            // console.log(`text_length=${text_length}`);
            // console.log(`length_001=${length_001}`);
            // console.log(`length_002=${length_002}`);
            // console.log(`length_003=${length_003}`);

            let s = ``;
            s += `${text}`;
            s = s.padStart(length_003, separator);
            s = s.padEnd(separator_length, separator);

            cache[key] = s;
        }

        return cache[key];
    };

    const log = function (pParameter) {
        const s = get(pParameter);
        console.log(s);
    };

    __this.get = get;
    __this.log = log;
};

module.exports = separation_line_helper;
