const get_query_string_object = require(`./get_query_string_object`);

const _ = require(`underscore`);


const defaultAppKey = 'default';
const defaultPlatformKey = 'default';

// const defaultAppKeyObsolete = 'localhost_dev';
const defaultPlatformKeyObsolete = 'localhost_dev';

const get_platform_information = function (pParameter) {
    const platformInformationList = global.NL.Config.platformInformationList;

    if (!platformInformationList) {
        console.error('NL.Config.js没有配置【platformInformationList】！');
        return;
    }

    if (!pParameter) {
        pParameter = {};
    }

    pParameter.url = pParameter.url || global.location.href;
    pParameter.webApiType = pParameter.webApiType || null;

    const queryStringObject = get_query_string_object({
        url: pParameter.url,
        isLowerCase: true
    });
    const platformKey = queryStringObject.platformkey || defaultPlatformKey;
    const appKey = queryStringObject.appkey || defaultAppKey;

    let platformInformation;
    switch (pParameter.webApiType) {
        case 'v3':
        case 'v2':
            //v3目录和v2目录，查找platformInformation实体时，以appKey来查找
            platformInformation = _.find(platformInformationList, function (m) {
                const flag = false;
                const appKey_temp = m.appKey;
                if (!appKey_temp) {
                    return flag;
                }
                return appKey_temp.toLowerCase().trim() === appKey.toLowerCase();
            });
            if (!platformInformation) {
                console.error('从platformInformationList中找不到appKey={0}的实体！', appKey);
                return;
            }
            break;
        default:
            //yxt目录（可以理解成v1目录），查找platformInformation实体时，以platformKey来查找
            platformInformation = _.find(platformInformationList, function (m) {
                const flag = false;
                const platformKey_temp = m.platformKey;
                if (!platformKey_temp) {
                    return flag;
                }

                const k = platformKey_temp.toLowerCase().trim();
                return 0 ||
                    k === platformKey.toLowerCase() ||
                    k === defaultPlatformKeyObsolete.toLowerCase()
                    ;
            });
            if (!platformInformation) {
                console.error(`从platformInformationList中找不到platformKey=${platformKey}或者platformKey=${defaultPlatformKeyObsolete}的实体！`);
                return;
            }
            break;
    }
    return platformInformation;
};

module.exports = get_platform_information;