// const extend = require(`extend`);
const _ = require(`underscore`);

const get_situation_type = require(`./get_situation_type`);

const get_query_string_entity_list = function (pParameter) {
    const uri = pParameter.uri;

    const getList_1 = function () {
        const list = [];

        const situationType = get_situation_type(uri);

        const process_situationType_200 = function () {
            let s = '';
            const reg = /.*?\?(.*)/gi;
            let result;
            while ((result = reg.exec(uri)) !== null) {
                if (result.length === 2) {
                    s = result[1];

                    const entity = {};
                    entity.fullQueryString = s;
                    entity.position = '000';
                    list.push(entity);
                }
            }
            return s;
        };
        const process_situationType_300 = function () {
            const s = '';
            const reg = /.*?\?(.*)#.*?\?(.*)/gi;
            let result;
            while ((result = reg.exec(uri)) !== null) {
                if (result.length === 3) {
                    let entity = {};
                    entity.fullQueryString = result[1];
                    entity.position = '000';
                    list.push(entity);

                    entity = {};
                    entity.fullQueryString = result[2];
                    entity.position = '100';
                    list.push(entity);
                }
            }
            return s;
        };
        const process_situationType_301 = function () {
            let s = '';
            const reg = /.*?\?(.*)#.*?/gi;
            let result;
            while ((result = reg.exec(uri)) !== null) {
                if (result.length === 2) {
                    s = result[1];

                    const entity = {};
                    entity.fullQueryString = s;
                    entity.position = '000';
                    list.push(entity);
                }
            }
            return s;
        };
        const process_situationType_302 = function () {
            let s = '';
            const reg = /.*?#.*?\?(.*)/gi;
            let result;
            while ((result = reg.exec(uri)) !== null) {
                if (result.length === 2) {
                    s = result[1];

                    const entity = {};
                    entity.fullQueryString = s;
                    entity.position = '100';
                    list.push(entity);
                }
            }
            return s;
        };

        switch (situationType) {
            case '100':
                //没有?，有#
                //不用处理
                break;

            case '200':
                //有?，没有#
                process_situationType_200();
                break;

            case '300':
                //有?，有#
                //有两个?
                process_situationType_300();
                break;

            case '301':
                //有?，有#
                //只有一个?
                //?在#之前
                process_situationType_301();
                break;

            case '302':
                //有?，有#
                //只有一个?
                //?在#之后
                process_situationType_302();
                break;

            default :
                //没有?，没有#
                //不用处理
                break;
        }

        return list;
    };
    const list1 = getList_1();

    const getList_2 = function () {
        const list = [];

        _.each(list1, function (tempEntity) {
            const fullQueryString = tempEntity.fullQueryString;
            const position = tempEntity.position;

            const array1 = fullQueryString.split('&');
            for (let i = 0; i < array1.length; i++) {
                const keyValueString = array1[i];
                if (keyValueString) {
                    const array2 = keyValueString.split('=');
                    const key = array2[0];
                    const value = array2[1];

                    const entity = {};
                    entity.key = key;
                    entity.value = value;
                    entity.position = position;
                    list.push(entity);
                }
            }

        });

        return list;
    };
    const list2 = getList_2();

    return list2;
};

module.exports = get_query_string_entity_list;