const extend = require(`extend`);
const _ = require(`underscore`);

const to_lower_case_property_name_object = require(`../convert/to_lower_case_property_name_object`);

const get_query_string_entity_list = require(`./get_query_string_entity_list`);

const get_query_string_object = function (pParameter) {
    const defaultParameter = {};
    defaultParameter.uri = ``;
    defaultParameter.isLowerCase = false;

    const parameter = extend(true, {}, defaultParameter, pParameter);

    const uri = parameter.uri || parameter.url || global.location.href;

    let queryStringObject = {};
    const queryStringEntityList = get_query_string_entity_list({
        uri: uri,
    });
    _.each(queryStringEntityList, function (queryStringEntity) {
        const key = queryStringEntity.key;
        const value = queryStringEntity.value;
        queryStringObject[key] = value;
    });

    if (parameter.isLowerCase) {
        queryStringObject = to_lower_case_property_name_object(queryStringObject);
    }
    return queryStringObject;
};

module.exports = get_query_string_object;