// const extend = require(`extend`);
const _ = require(`underscore`);

const get_situation_type = function (pUri) {
    //situationType

    //100
    //没有?，有#
    //http://localhost/JxptFrontEnd/mobile/yxt/index-login.html#/tab/resources

    //200
    //有?，没有#
    //http://localhost/JxptFrontEnd/mobile/yxt/index-login.html?platformkey=16test&appcode=123

    //300
    //有?，有#，有两个?
    //http://localhost/JxptFrontEnd/mobile/yxt/index-login.html?platformkey=16test&appcode=123#/tab/resources?resourcetype=image&pageindex=2

    //301
    //有?，有#，只有一个?，?在#之前
    //http://localhost/JxptFrontEnd/mobile/yxt/index-login.html?platformkey=16test&appcode=123#/tab/resources

    //302
    //有?，有#，只有一个?，?在#之后
    //http://localhost/JxptFrontEnd/mobile/yxt/index-login.html#/tab/resources?resourcetype=image&pageindex=2

    //default
    //没有?，没有#
    //http://localhost/JxptFrontEnd/mobile/yxt/index-login.html

    const index1 = pUri.indexOf('?');
    const index2 = pUri.indexOf('#');

    let returnSituationType = '000';
    if (index1 === -1 && index2 === -1) {
        //没有?，没有#
    } else if (index1 === -1 && index2 > -1) {
        //没有?，有#
        returnSituationType = '100';
    } else if (index1 > -1 && index2 === -1) {
        //有?，没有#
        returnSituationType = '200';
    } else if (index1 > -1 && index2 > -1) {
        //有?，有#

        const index1_first = index1;
        const index1_last = _.lastIndexOf(pUri, '?');

        if (index1_first !== index1_last) {
            //有两个?
            returnSituationType = '300';
        } else {
            //只有一个?

            if (index1 < index2) {
                //?在#之前
                returnSituationType = '301';
            } else {
                //?在#之后
                returnSituationType = '302';
            }
        }
    }

    return returnSituationType;
};

module.exports = get_situation_type;