const join = function () {
    const separator = '/';

    const check_rule_01 = function (pString) {
        let flag = false;
        if (typeof pString !== 'string') {
            return flag;
        }
        pString = pString.trim();
        if (!pString) {
            return flag;
        }

        flag = true;
        return flag;
    };
    const check_rule_02 = function (pString) {
        let flag = true;
        if (pString.length > 0) {
            const first = pString[0];
            if (first === separator) {
                flag = false;
            }
        }
        return flag;
    };
    const check_rule_03 = function (pString) {
        let flag = true;
        if (pString.length > 0) {
            const last = pString[pString.length - 1];
            if (last !== separator) {
                flag = false;
            }
        }
        return flag;
    };

    const array = arguments;
    let returnValue = '';
    for (let i = 0; i < array.length; i++) {
        let path = array[i];
        if (!check_rule_01(path)) {
            continue;
        }
        //如果当前path不是第一个字符
        if (!check_rule_02(path)) {
            //如果当前path第一个字符为/，删除第一个字符
            path = path.substring(1);
        }

        if (!check_rule_03(path)) {
            //如果当前path最一个字符不为/，追加/到最后一个字符
            path = path + separator;
        }

        returnValue += path;
    }

    if (array.length > 0) {
        const firstPath = array[0];
        if (!check_rule_02(firstPath)) {
            //如果当前path第一个字符为/，在最前面补回字符/，因为之前删除了
            returnValue = '/' + returnValue;
        }

        const lastPath = array[array.length - 1];
        if (!check_rule_03(lastPath)) {
            //如果当前path最一个字符不为/，在最后面删除字符/，因为之前追加了
            returnValue = returnValue.slice(0, returnValue.length - 1);
        }
    }

    return returnValue;
};
module.exports = join;