const _ = require(`underscore`);

const Dict = require(`../../../dict`);

const dict_reg = new Dict({
    initType: `000`,
    initParameter: {
        '000': {
            entityDefine: {
                text: `key`,
                value: `value`
            },
            entityList: [
                {
                    key: `phone`,
                    value: /^1[3-9][0-9]{9}$/gi,
                    check(pParameter) {
                        const __this = this;

                        if (!pParameter) pParameter = {};
                        const value = pParameter.value;

                        const reg = new RegExp(__this.value);
                        const flag = reg.test(value);

                        return flag;
                    },
                    remarks: `手机号码`,
                },
            ]
        }
    }
});

// console.log(dict_reg.map.phone);
// console.log(dict_reg.mapEntity.phone);

_.bindAll(dict_reg.mapEntity.phone, `check`);

module.exports = dict_reg;
