/**
 * @module nllib
 */

/**
 * 获取dom
 *
 * @class nllib/src/xpath/get_element
 * @static
 * @param {object} pParameter
 * @param {string} pParameter.selector xpath选择器
 * @return {object} dom
 *
 * @demo src/xpath/get_element/1.0.0/demo/index.demo.js
 */
const get_element = function (pParameter) {
    if (!pParameter) pParameter = {};
    const selector = pParameter.selector || ``;

    const document = window.document;
    const XPathResult = window.XPathResult;

    const aXPathResult = document.evaluate(selector, document, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
    const element = aXPathResult.iterateNext();
    return element;
};

module.exports = get_element;
