/**
 * @module nllib
 */

/**
 * 获取dom列表
 *
 * @class nllib/src/xpath/get_element_list
 * @static
 * @param {object} pParameter
 * @param {string} pParameter.selector xpath选择器
 * @return {array} dom列表
 *
 * @demo src/xpath/get_element_list/1.0.0/demo/index.demo.js
 */
const get_element_list = function (pParameter) {
    if (!pParameter) pParameter = {};
    const selector = pParameter.selector || ``;

    const document = window.document;
    const XPathResult = window.XPathResult;

    const aXPathResult = document.evaluate(selector, document, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);

    const list = [];

    let element = aXPathResult.iterateNext();
    while (element) {
        list.push(element);
        element = aXPathResult.iterateNext();
    }
    return list;
};

module.exports = get_element_list;
