//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
const extend = require(`extend`);
const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);
// const URI = require(`urijs`);
//</editor-fold>

const __request_v2 = require(`./__request_v2`);

//文档地址：http://192.168.9.18:8087/index.html#!/org/get_api_v2_dept_findOrgByProperties

module.exports = function (pParameter) {
    const defaultParameter = {};
    defaultParameter.environment = ``;

    const parameter = extend(true, {}, defaultParameter, pParameter);

    const environment = parameter.environment;

    return Q.when()
        .then(function () {
            return __request_v2({
                environment: environment,
                uriSuffix: `api/v2/dept/findOrgByProperties`,
                data: parameter,
            });
        })
        .then(function (data) {
            if (!data) {
                const msg = `__api_v2_dept_findOrgByProperties parameter error, code=000`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            return Q.resolve(data);
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};