//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
const extend = require(`extend`);
const Q = require(`q`);
// const _ = require(`underscore`);
const moment = require(`moment`);
// const URI = require(`urijs`);
const md5 = require(`blueimp-md5`);
const rp = require(`request-promise`);
//</editor-fold>

const get_config = require(`./get_config`);
const uri_join = require(`../../../uri/join`);

module.exports = function (pParameter) {
    const enable_fiddler = global.process.env.nllib_enable_fiddler;

    const defaultParameter = {};
    defaultParameter.environment = '';
    defaultParameter.method = `get`;
    defaultParameter.uriSuffix = `uri-suffix-not-set`;
    defaultParameter.data = {};

    const parameter = extend(true, {}, defaultParameter, pParameter);

    const environment = parameter.environment;
    const method = parameter.method;
    const uriSuffix = parameter.uriSuffix;
    const data = parameter.data;

    const config = get_config({environment: environment});
    // console.log(`config=${JSON.stringify(config, null, 4)}`);

    const appId = config.appId;
    const secret = config.secret;
    const uriPrefix = config.uriPrefix;

    const timeStr = moment().format(`x`);
    const code = md5(secret + timeStr);

    const uri = uri_join(uriPrefix, uriSuffix);
    const proxy = enable_fiddler ? `http://127.0.0.1:8888` : undefined;

    const qs = extend(true, {}, data);
    qs.appid = appId;
    qs.timeStr = timeStr;
    qs.code = code;

    const options = {
        method: method,
        uri: uri,
        proxy: proxy,
        qs: qs,
        json: true // Automatically stringifies the body to JSON
    };

    return rp(options)
        .then(function (parsedBody) {
            // res.write(JSON.stringify(parsedBody));
            return Q.resolve(parsedBody);
        })
        .catch(function (ex) {
            console.error(ex);
        })
        ;
};