//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
const extend = require(`extend`);
const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);
// const URI = require(`urijs`);
//</editor-fold>

const __request_v2 = require(`./__request_v2`);

module.exports = function (pParameter) {
    const defaultParameter = {};
    defaultParameter.environment = ``;

    const parameter = extend(true, {}, defaultParameter, pParameter);

    const environment = parameter.environment;
    const userId = parameter.userId;
    const platformKey = parameter.platformKey;
    const token = parameter.token;

    return Q.when()
        .then(function () {
            return __request_v2({
                environment: environment,
                uriSuffix: `v1/sso/confirmBySecurity`,
                data: {
                    userId: userId,
                    platformKey: platformKey,
                    token: token,
                }
            });
        })
        .then(function (data) {
            // console.log(JSON.stringify(data, null, 4));
            
            if (!data) {
                const msg = '__v1_sso_confirmBySecurity.js parameter error, code=000';
                console.error(msg);
                return Q.reject({msg: msg});
            }

            if (!data.token) {
                const msg = '__v1_sso_confirmBySecurity.js parameter error, code=001';
                console.error(msg);
                return Q.reject({msg: msg});
            }

            return Q.resolve(data);
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};