//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
const extend = require(`extend`);
const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);
// const URI = require(`urijs`);
//</editor-fold>

const get_config = require(`./get_config`);
const __request_v2 = require(`./__request_v2`);

module.exports = function (pParameter) {
    const defaultParameter = {};
    defaultParameter.environment = ``;

    const parameter = extend(true, {}, defaultParameter, pParameter);

    const environment = parameter.environment;

    const config = get_config({environment: environment});
    // console.log(`config=${JSON.stringify(config, null, 4)}`);

    const userName = parameter.userName || config.user_001.userName;
    const password = parameter.password || config.user_001.password;
    const isNeedActive = true;

    return Q.when()
        .then(function () {
            return __request_v2({
                environment: environment,
                uriSuffix: `v1/sso/loginBySecurity`,
                data: {
                    username: userName,
                    password: password,
                    isNeedActive: isNeedActive,
                }
            });
        })
        .then(function (data) {
            // console.log(JSON.stringify(data, null, 4));

            if (!data) {
                const msg = '__v1_sso_loginBySecurity parameter error, code=000';
                console.error(msg);
                return Q.reject({msg: msg});
            }

            if (!data.token) {
                const msg = '__v1_sso_loginBySecurity parameter error, code=001';
                console.error(msg);
                return Q.reject({msg: msg});
            }

            const list = data.data;
            if (!list) {
                const msg = '__v1_sso_loginBySecurity parameter error, code=002';
                console.error(msg);
                return Q.reject({msg: msg});
            }
            if (list.length <= 0) {
                const msg = '__v1_sso_loginBySecurity parameter error, code=003';
                console.error(msg);
                return Q.reject({msg: msg});
            }

            return Q.resolve(data);
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};