//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
const extend = require(`extend`);
const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);
// const URI = require(`urijs`);
//</editor-fold>

const __request_v1 = require(`./__request_v1`);

module.exports = function (pParameter) {
    const defaultParameter = {};
    defaultParameter.environment = ``;
    defaultParameter.ticket = ``;

    const parameter = extend(true, {}, defaultParameter, pParameter);

    const environment = parameter.environment;
    const ticket = parameter.ticket;

    return Q.when()
        .then(function () {
            return __request_v1({
                environment: environment,
                uriSuffix: `v2/oauth/token/get`,
                data: {
                    ticket: ticket,
                }
            });
        })
        .then(function (data) {
            if (!data) {
                const msg = `__v2_oauth_token_get parameter error, code=000`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            if (!data.token) {
                const msg = `__v2_oauth_token_get parameter error, code=001`;
                console.error(msg);
                return Q.reject({msg: msg});
            }
            
            return Q.resolve(data);
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};