//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
// const extend = require(`extend`);
const Q = require(`q`);
const _ = require(`underscore`);
// const moment = require(`moment`);
// const URI = require(`urijs`);
//</editor-fold>

const __request = require(`./__request`);

const __api_v1_dept_getClassList = function () {

    //接口文档：
    //http://192.168.9.18/wiki/pages/viewpage.action?pageId=18481208

    return Q.when()
        .then(function () {
            return __request({
                uriSuffix: `api/v1/dept/getClassList`,
                data: {},
            });
        })
        .then(function (pData) {
            if (!pData) {
                const msg = `__api_v1_dept_getClassList parameter error, code=000`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            const data = pData.data;
            if (!data) {
                const msg = `__api_v1_dept_getClassList parameter error, code=001`;
                console.error(msg);
                return Q.reject({msg: msg});
            }
            if (!_.isArray(data)) {
                const msg = `__api_v1_dept_getClassList parameter error, code=002`;
                console.error(msg);
                return Q.reject({msg: msg});
            }
            if (data.length <= 0) {
                const msg = `__api_v1_dept_getClassList parameter error, code=003`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            for (let i = 0; i < data.length; i++) {
                const entity = data[i];
                if (!entity) {
                    const msg = `__api_v1_dept_getClassList parameter error, code=201`;
                    console.error(msg);
                    return Q.reject({msg: msg});
                }

                const classId = entity.classId;
                if (!classId) {
                    const msg = `__api_v1_dept_getClassList parameter error, code=202`;
                    console.error(msg);
                    return Q.reject({msg: msg});
                }
            }

            return Q.resolve(pData);
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};

module.exports = __api_v1_dept_getClassList;