//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
// const extend = require(`extend`);
const Q = require(`q`);
const _ = require(`underscore`);
// const moment = require(`moment`);
// const URI = require(`urijs`);
//</editor-fold>

const __request = require(`./__request`);

const __api_v1_user_getUserInfo = function () {

    //接口文档：
    //http://192.168.9.18/wiki/pages/viewpage.action?pageId=18481296

    return Q.when()
        .then(function () {
            return __request({
                uriSuffix: `api/v1/user/getUserInfo`,
                data: {},
            });
        })
        .then(function (pData) {
            if (!pData) {
                const msg = `__api_v1_user_getUserInfo parameter error, code=000`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            const data = pData.data;
            if (!data) {
                const msg = `__api_v1_user_getUserInfo parameter error, code=001`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            const guId = data.guId;
            if (!guId) {
                const msg = `__api_v1_user_getUserInfo parameter error, code=002`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            const list = guId.split(`-`);
            if (!list) {
                const msg = `__api_v1_user_getUserInfo parameter error, code=101`;
                console.error(msg);
                return Q.reject({msg: msg});
            }
            if (!_.isArray(list)) {
                const msg = `__api_v1_user_getUserInfo parameter error, code=102`;
                console.error(msg);
                return Q.reject({msg: msg});
            }
            if (list.length !== 2) {
                const msg = `__api_v1_user_getUserInfo parameter error, code=103`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            const dbId = list[0];
            if (!dbId) {
                const msg = `__api_v1_user_getUserInfo parameter error, code=104`;
                console.error(msg);
                return Q.reject({msg: msg});
            }

            data.dbId = dbId;
            return Q.resolve(pData);
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};

module.exports = __api_v1_user_getUserInfo;