//<editor-fold desc="node core modules">
// const path = require('path');
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require('fs-extra');
const extend = require('extend');
const Q = require('q');
// const _ = require('underscore');
// const moment = require('moment');
// const URI = require('urijs');
//</editor-fold>

const __v1_sso_login_jsonp = require(`./__v1_sso_login_jsonp`);
const __v2_oauth_token_get = require(`./__v2_oauth_token_get`);

module.exports = function (pParameter) {
    const defaultParameter = {};
    defaultParameter.environment = '';

    const parameter = extend(true, {}, defaultParameter, pParameter);

    const environment = parameter.environment;

    return Q.when()
        .then(function () {
            return __v1_sso_login_jsonp({
                environment: environment,
            });
        })
        .then(function (data) {
            const ticket = data.NLTicket;

            return __v2_oauth_token_get({
                environment: environment,
                ticket: ticket,
            })
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};