//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
const extend = require(`extend`);
const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);
// const URI = require(`urijs`);
//</editor-fold>

const join = require(`../../../uri/join`);
const get_token = require(`../../../model/get_token`);
const get_environment = require(`../../../model/get_environment`);
const request_webApiType_v2 = require(`../../../model/request_webApiType_v2`);

const __get_sso_config = require(`./__get_sso_config`);

module.exports = function (pParameter) {
    if (!pParameter) {
        pParameter = {};
    }

    const defaultParameter = {};
    defaultParameter.type = `post`;
    defaultParameter.uriSuffix = `/`;
    defaultParameter.data = {};

    const parameter = extend({}, defaultParameter, pParameter);

    const environment = get_environment();
    if (!environment) {
        const msg = '__request parameter error, code=001';
        console.error(msg);
        return Q.reject({msg: msg});
    }

    const token = get_token();
    if (!token) {
        const msg = '__request parameter error, code=002';
        console.error(msg);
        return Q.reject({msg: msg});
    }

    const sso_config = __get_sso_config({
        environment: environment,
    });
    if (!sso_config) {
        const msg = '__request parameter error, code=003';
        console.error(msg);
        return Q.reject({msg: msg});
    }

    return Q.when()
        .then(function () {
            return request_webApiType_v2({
                type: parameter.type,
                uriSuffix: parameter.uriSuffix,
                data: parameter.data,
                headers: {
                    authorization: token,
                },
                getUrl: function () {
                    const uriPrefix = sso_config.uriPrefix;
                    const uriSuffix = pParameter.uriSuffix;
                    const url = join(uriPrefix, uriSuffix);
                    return url;
                }
            });
        })
        ;
};