//<editor-fold desc="node core modules">
// const path = require(`path`);
//</editor-fold>

//<editor-fold desc="npm modules">
// const fs = require(`fs-extra`);
const extend = require(`extend`);
const $ = require(`jquery`);
const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);
// const URI = require(`urijs`);
//</editor-fold>

module.exports = function (pParameter) {
    const defaultParameter = {};
    defaultParameter.environment = ``;
    defaultParameter.ticket = ``;

    const parameter = extend(true, {}, defaultParameter, pParameter);

    const environment = parameter.environment;
    const ticket = parameter.ticket;

    let url = `http://server.frontend.jxt189.com/api/sso/v2/oauth/token/get`;
    url += `?environment=${environment}`;
    // let url = `http://127.0.0.1:3000/api/sso/v2/oauth/token/get`;
    // url += `?environment=${environment}`;

    const options = {
        type: `post`,
        // contentType: `application/json;charset=utf-8`,
        // dataType: `json`,
        url: url,
        data: {
            environment: environment,
            ticket: ticket,
        },
    };

    return Q.when()
        .then(function () {
            return $.ajax(options);
        })
        .then(function (data) {
            if (!data) {
                const msg = '__sso_v2_oauth_token_get parameter error, code=000';
                console.error(msg);
                return Q.reject({msg: msg});
            }

            const token = data.token;
            if (!token) {
                const msg = '__sso_v2_oauth_token_get parameter error, code=001';
                console.error(msg);
                return Q.reject({msg: msg});
            }

            return Q.resolve(data);
        })
        .catch(function (ex) {
            console.error(ex);
            if (ex) {
                if (ex.stack) {
                    console.error(ex.stack);
                }
            }
            return Q.reject(ex);
        })
        ;
};