describe('redictType=210，requestId、environment和redirectUrl为必填参数', function () {

    describe.only('default', function () {
        const testCaseList = [
            {
                msg: '默认使用方法',
                src: {
                    url: `http://127.0.0.1/index-redirect.html?environment=alpha&requestId=111&redirectUrl=` + encodeURIComponent('http://127.0.0.1/index-app.html'),
                },
                dest: {
                    "flag": true,
                    "msg": "",
                    "data": {
                        "environment": "alpha",
                        "requestId": "111",
                        "redirectUrl": "http://127.0.0.1/index-app.html",
                        "origin_redirectUrl_decode": "http://127.0.0.1/index-app.html",
                        "origin_redirectUrl_encode": encodeURIComponent('http://127.0.0.1/index-app.html')
                    }
                }
            },

        ];

        _.each(testCaseList, function (testCase) {
            const src = testCase.src;
            const dest = testCase.dest;

            it(testCase.msg, function (done) {
                const aRedirectHelper = new NL.systemDocking.sso.frontend.redirectHelper({
                    redirectType: '210',
                    url: src.url,
                    redirectTypeParameter: {
                        '210': {
                            get_token: function (args) {
                                const requestId = args.requestId;
                                const data = {};
                                data.token = `999`;
                                return Q.resolve(data);
                            }
                        }
                    }
                });

                aRedirectHelper.init();
                aRedirectHelper.getReturnValue().then(function (aReturnValue) {
                    console.log(aReturnValue);
                    expect(aReturnValue.flag).to.eql(dest.flag);
                    expect(aReturnValue.msg).to.eql(dest.msg);

                    expect(aReturnValue.data.environment).to.eql(dest.data.environment);
                    expect(aReturnValue.data.requestId).to.eql(dest.data.requestId);

                    const uri_expect = URI(dest.data.redirectUrl);
                    const uri_actual = URI(aReturnValue.data.redirectUrl);

                    expect(uri_actual.path()).to.eql(uri_expect.path());

                    const queryStringObject_expect = NL.uri.get_query_string_object({uri: dest.data.redirectUrl});
                    const queryStringObject_actual = NL.uri.get_query_string_object({uri: aReturnValue.data.redirectUrl});

                    expect(queryStringObject_actual.appkey).to.eql(queryStringObject_expect.appkey);
                    expect(queryStringObject_actual).to.have.property('nlVersion');

                    done();
                }).catch(function (ex) {
                    console.error(ex);
                });
            });
        })

    });

});