const path = require(`path`);
const fs = require(`fs-extra`);

const extend = require(`extend`);
const Q = require(`q`);
const _ = require(`underscore`);
const moment = require(`moment`);
const axios = require(`axios`);

//https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html#62

const get = function (pParameter) {
    if (!pParameter) pParameter = {};
    const access_token = pParameter.access_token || ``;
    const type = pParameter.type || `jsapi`;

    if (!access_token) {
        const msg = `src/system-docking/weixin/gong-zhong-hao/cgi-bin/ticket/getticket parameter error, code=001`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    const url = `https://api.weixin.qq.com/cgi-bin/ticket/getticket`;

    return Q.when()
        .then(function () {
            return axios({
                method: `get`,
                url,
                params: {
                    access_token,
                    type,
                },

                // proxy: {
                //     host: '127.0.0.1',
                //     port: 8888,
                // },

            });
        })
        .then(function (response) {
            const data = response.data;
            // console.log(JSON.stringify(data, null, 4));

            const ticket = data.ticket;
            if (!ticket) {
                const msg = `src/system-docking/weixin/gong-zhong-hao/cgi-bin/ticket/getticket::get parameter error, code=001`;
                console.error(msg);
                console.trace();
                return Q.reject({msg: msg});
            }

            return Q.resolve(data);
        })
        .catch(function (ex) {
            if (ex) {
                const enable_log_error = !ex.disable_log_error;
                if (enable_log_error) {
                    console.error(ex);
                    console.trace();
                    if (ex.stack) {
                        console.error(ex.stack);
                    }
                }
            }
            return Q.reject(ex);
        })
        ;
};

module.exports = get;
