// const path = require(`path`);
// const fs = require(`fs-extra`);
// const extend = require(`extend`);
const Q = require(`q`);
// const _ = require(`underscore`);
// const moment = require(`moment`);
const axios = require(`axios`);

//https://developers.weixin.qq.com/miniprogram/dev/api-backend/open-api/login/auth.code2Session.html
const get_open_id = function (pParameter) {
    if (!pParameter) pParameter = {};
    const appId = pParameter.appId;
    const appSecret = pParameter.appSecret;
    const js_code = pParameter.js_code;

    if (!appId) {
        const msg = `get_open_id parameter error, code=001`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }
    if (!appSecret) {
        const msg = `get_open_id parameter error, code=002`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }
    if (!js_code) {
        const msg = `get_open_id parameter error, code=003`;
        console.error(msg);
        console.trace();
        return Q.reject({msg: msg});
    }

    return Q.when()
        .then(function () {
            const url = `https://api.weixin.qq.com/sns/jscode2session?appid=${appId}&secret=${appSecret}&js_code=${js_code}&grant_type=authorization_code`;
            return axios({
                method: `GET`,
                url,
            });
        })
        .then(function (response) {
            return Q.resolve(response.data);
        })
        .catch(function (ex) {
            if (ex) {
                const enable_log_error = !ex.disable_log_error;
                if (enable_log_error) {
                    console.error(ex);
                    console.trace();
                    if (ex.stack) {
                        console.error(ex.stack);
                    }
                }
            }
            return Q.reject(ex);
        })
        ;
};

module.exports = get_open_id;
