//<editor-fold desc="node core modules">
const path = require('path');
//</editor-fold>

//<editor-fold desc="npm modules">
const fs = require('fs-extra');
const extend = require('extend');
const Q = require('q');
const _ = require('underscore');
const moment = require('moment');
const URI = require('urijs');
//</editor-fold>

const exec = require(`../../child_process/exec`);

const __exec_windows = function (pCmd, pOptions) {
    if (!pOptions) {
        pOptions = {};
    }

    const _env = pOptions.env;
    const env = extend({}, _env);

    const cmd = pCmd;

    const defer = Q.defer();

    const childProcess = exec(cmd, {
        os: 'windows',
        env: env
    });
    childProcess.stdout.on('data', function (chunk) {
        const textChunk = chunk.toString('utf-8');
        console.log(textChunk);
    });
    childProcess.stderr.on('data', function (chunk) {
        const textChunk = chunk.toString('utf-8');
        console.error(textChunk);
    });
    childProcess.on('exit', function (code) {
        // console.log('exit code : ' + code);
        // console.log('exit event');
    });
    childProcess.on('close', function (code) {
        console.log('close code : ' + code);
        // console.log('close event');

        if (!code) {
            defer.resolve({
                code: code
            });
        } else {
            defer.reject({
                code: code
            });
        }
    });

    return defer.promise;
};

module.exports = __exec_windows;
